module data_wavelet
  use global_params_mod
  use map_mod
  implicit none
contains
  !==========================================#
 subroutine data_wavelets()
    integer             :: iw, niw
    real                :: w 
    real    			:: max_t
    character(len=1024) :: string
    wavelet_="wavelet"; 
!read the source wavelet from file    
    call auxin(wavelet_) 
	call hinaxis(wavelet_,dgrid%aw,3); 
    allocate(csou(dgrid%aw%n))
    if(exist_file(wavelet_))call sreed(wavelet_, csou, 8*dgrid%aw%n)
!	if (dgrid%aw%n/=ggrid%aw%n) call seperr('Source wavelet must have same num. of freq. as greens.')

!initialize the data time axis.
    max_t=1/dgrid%aw%d
    dgrid%at%n=dgrid%aw%n
    dgrid%at%d=(max_t-dgrid%at%o)/(dgrid%at%n-1)
    call data_radians_calc()
    call gre_radians_calc()

    write(0,'(A65)')'========================Summary wavelet================================='
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Data  Time  ax','|',dgrid%at, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Data  Freq. ax','|',dgrid%aw, '|'
    write(0,'(A2,A15,A2,I10,2(F10.3,2X),A10,A2)') '|','Green Freq. ax','|',ggrid%aw, '|'
    write(0,'(A65)')'------------------------------------------------------------------'
    write(*,'(A2,A15,A2,F10.3,A8)')'|','Min. Freq.','|',mcsou,'radians'
    write(*,'(A2,A15,A2,F10.3,A8)')'|','Max. Freq.','|',mcsou+(ggrid%aw%n-1)*ggrid%aw%d,'radians'
    write(0,'(A65)')'End wavelet============================================================='
  end subroutine
  end module
