      program test
use myfft_mod
use fftw_oneway_mod

      implicit none

!#include "fftw3.f"

      integer N,m,m2
      parameter(N=5)
      parameter(m=5)
      parameter(m2=1)

      integer*8 plan,plan2
      integer*8 plan2d
      double complex in, out
      real inn,in2d
      complex icn,icn2
      complex outt,out2d
      dimension in(N),out(N),icn(N)
      dimension inn(N),outt(N/2+1)
      dimension in2d(m,m2),out2d(m/2+1,m2/2+1)
      dimension icn2(m,m2)

      integer i,j


      call sfftw_plan_dft_r2c_1d ( plan , N, inn, outt, FFTW_ESTIMATE ); 
      call sfftw_plan_dft_c2r_1d ( plan2, N, outt, inn, FFTW_ESTIMATE ); 

      write(0,*)plan
      write(0,*)plan2
      write(*,*) 'Input array:'
      do i = 1,N,1; inn(i) = cmplx(float(i),0); write(*,*) '    in(',i,') = ',inn(i); enddo
      call sfftw_execute ( plan ); outt=outt*sqrt(1./N)
      write(*,*) 'Output array:'
      do i = 1,N/2+1,1; write(*,*) '    out(',i,') = ',outt(i); enddo
      call sfftw_execute ( plan2); inn=inn*sqrt(1./N)
      write(*,*) 'Input after inverse FFT:'
      do i = 1,N,1; write(*,*) '    in(',i,') = ',inn(i); enddo
      write(0,*)outt(:)


      stop
      icn=0.
      icn(1:n/2+1)=outt
      write(0,*)'****'
      write(0,*)icn
write(0,*)'--------1'
      call fftw_init1d(n)
      call fftw_exec1d(-1,icn)
      write(0,*)real(icn)
write(0,*)'--------2'
      call fftw_exec1d(1,icn)
      write(0,*)icn
write(0,*)'--------'

write(0,*)'--------'
write(0,*)'--------'
write(0,*)'--------'
write(0,*)'--------'
write(0,*)'--------'
write(0,*)'--------'
      call sfftw_plan_dft_r2c_2d ( plan , m,m2, in2d, out2d, FFTW_ESTIMATE ); 
      call sfftw_plan_dft_c2r_2d ( plan2, m,m2, out2d, in2d, FFTW_ESTIMATE ); 
      write(*,*) 'Input array:'
      do i = 1,m,1; do j=1,m2; in2d(i,j) = cmplx(float(i),float(j)); enddo; write(*,'(A9,I5,A6,8F10.5)') 'in(',i,') = ',in2d(i,:); enddo ; 
      call sfftw_execute (plan); 
      do i=1, m/2+1;out2d(i,:)=out2d(i,:)*sqrt(1./m );enddo
      do i=1,m2/2+1;out2d(:,i)=out2d(:,i)*sqrt(1./m2);enddo

      write(*,*) 'Output array:'
      do i = 1,m/2+1;                            write(*,'(A9,I5,A6,8F10.5)') 'out(',i,') = ',out2d(i,:); enddo
      call sfftw_execute ( plan2)
      do i=1, m;in2d(i,:)=in2d(i,:)*sqrt(1./m );enddo
      do i=1,m2;in2d(:,i)=in2d(:,i)*sqrt(1./m2);enddo

      write(*,*) 'Input after inverse FFT:'
      do i = 1,m;                                write(*,'(A9,I5,A6,8F10.5)') 'in(',i,') = ',in2d(i,:); enddo

      icn2=0.
      icn2(1:m/2+1,1:m2/2+1)=out2d
      do i = 1,m,1; write(*,'(A9,I5,A6,8F10.5)') 'in--(',i,') = ',icn2(i,:); enddo ; 
      write(0,*)'****+++++'
write(0,*)'--------00001'
      call fftw_init2d(m,m2)
      call fftw_exec2d(-1,icn2)
      write(*,*) 'Output array:'
      do i = 1,m/2+1;                            write(*,'(A9,I5,A6,8F10.5)') 'out--(',i,') = ',icn2(i,:); enddo
write(0,*)'--------000002'
      call fftw_exec2d(1,icn2)
      write(*,*) 'Input after inverse FFT:'
      do i = 1,m;                                write(*,'(A9,I5,A6,8F10.5)') 'in(',i,') = ',icn2(i,:); enddo
write(0,*)'--------'











stop
      write(*,*) 'Input array:'

      do i = 1,N,1
        in(i) = dcmplx(float(i),float(i+1))
        write(*,*) '    in(',i,') = ',in(i)
      enddo

      call dfftw_plan_dft_1d ( plan, N, in, out, FFTW_FORWARD, FFTW_ESTIMATE )

      call dfftw_execute ( plan )

      write(*,*) 'Output array:'
      do i = 1,N,1
        write(*,*) '    out(',i,') = ',out(i)
      enddo

      call dfftw_destroy_plan ( plan )

      call dfftw_plan_dft_1d ( plan, N, out, in, FFTW_BACKWARD, FFTW_ESTIMATE )

      call dfftw_execute ( plan )

      write(*,*) 'Output array after inverse FFT:'
      do i = 1,N,1
        write(*,*) '    ',N,' * in(',i,') = ',in(i)/N
      enddo

      call dfftw_destroy_plan ( plan )

      in=in/N

      call dfftw_plan_dft_1d ( plan, N, in, out, FFTW_FORWARD, FFTW_ESTIMATE )

      call dfftw_execute ( plan )

      write(*,*) 'Output array after forward FFT:'
      do i = 1,N,1
        write(*,*)'  out(',i,') = ',out(i)
      enddo
      call dfftw_destroy_plan ( plan )


      end

