program main
  use hessian_convolve_mod
  use hessian_convolve_params
  use minres_mod
  use solver_me 
  use cgstep_mod
  use cg_step_mod
  use solver_smp_mod  
  use solver_reg_mod
  use solver_prc_mod
  use solver_yax_mod

!hybrid norm
  use solver_reg_nrm_mod   !General Norm
  use cgstep_module
  use solver_hybrid_mod

  use minres_mod
  

  implicit none
  logical :: ldip,lvdip

!######## sep-init stuff
  call sep_init(SOURCE); call getch_add_string("head=/dev/null"); call getch_add_string("noheader=y"); call set_no_putch();  call sep_begin_prog()
!########

  call date_and_time(values=time_array_3)
  start_t = time_array_3 (5) * 3600 + time_array_3 (6) * 60  + time_array_3 (7) + 0.001 * time_array_3 (8)

  stat = conv_init() 
  
   call from_param("ldip"    ,ldip        , F);
   call from_param("lvdip"   ,lvdip       , F);

!    write(0,*)sum(modl),sum(modl1),sum(modl2)
!    write(0,*)sum(data),sum(data1),sum(data2)
!    
!    write(0,*)'++++++++++'
!
!   stat = conv_oper(F,F,modl,data)
!   call hessian_conv_output()
!   stat = conv_clos()
!
!stop
!write(0,*)maxval(wght),minval(wght)
!         call vns_init(hgrid%az_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, 1, nsurv)
!         stat = hessian_convolve_temp_oper3(F,F,data,modl)
!         stat = vspatial_diff_oper(F,F,data,modl) 
!         stat = vspatial_diff_oper_4dsmth(F,F,data,modl)
!         stat = vspatial_diff_oper_smth(F,F,data,modl)
!         stat = vspatial_diff_oper_smth(F,F,data,modl)
!         call hessian_conv_output()
!         stat = vspatial_diff_oper(F,F,data,modl)
!         call hessian_conv_output()
!         stat = vspatial_diff_oper3(F,F,data,modl)
!         stat = vspatial_diff_oper_smth(F,F,data,modl) 
!         stat = hessian_convolve_temp_oper1(F,F,data,modl)
!         stat = vspatial_diff_oper(F,F,data,modl)
!          stat = vspatial_diff_oper3_smth(F,F,data,modl)
!         call hessian_conv_output()
! stop
  if(ldip)then
        if (lvdip)then
                call vns_init(hgrid%az_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, 1, nsurv)
        else
                  call  ns_init(hgrid%az_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, 1, nsurv)
        endif          
        !stat=hessian_convolve_dips_oper(T,F,modl,data)
  endif
!                  call  ns_init(hgrid%az_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, 1, nsurv)
  
  if (inv)then
          if (mode==1)then
                  if(weight .and. msk)then
                          write(*,*)'Starting Default Masked Masked CG inversion..........................'
                  !        call solver_cg(m=modl, d=data, Fop=conv_oper, Jop=conv_mask_oper,   niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                  elseif(weight .and. (.not. msk))then
                          write(*,*)'Starting Default Weighted CG inversion..........................'
                  !        call solver_cg(m=modl, d=data, Fop=conv_oper, Wop=conv_weight_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                  elseif((.not. weight) .and. msk)then
                          write(*,*)'Starting Default Masked CG inversion..........................'
                  !        call solver_cg(m=modl, d=data, Fop=conv_oper, Jop=conv_weight_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                  else
                          write(*,*)'Starting Default CG inversion no weight no mask....................'
                          call solver_cg(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
                  endif
          elseif(mode==2)then
                  write(*,*)'Starting 2nd CG inversion..............................'
  !                call solver_cg2(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
          elseif(mode==3)then
                  write(*,*)'Starting Bi CG inversion...............................'
  !                call solver_bicg(m=modl, d=data, Fop=conv_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb)
          elseif(mode==4)then  
                  write(*,*)'Starting Precond CG inversion...........................' 
                  call solver_pre_cg(m=modl, d=data, Fop=conv_oper, Sop=conv_precon_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb,tol=tol)
                 ! call seperr('Not working yet...')
          elseif(mode==5)then
                  write(*,*)'Starting GMRES..............................Not working fine yet'
  !               call MINRES( n=n, Aprod=hess_convolve3, Msolve=hess_precond, b=data_mres, shift=0.0_dp, checkA=.false., precon=.false., &
  !                                x=mod!l_mres, itnlim=niter, nout=6, rtol= 1.0e-12_dp ,                       &
  !                                istop=istop, itn=itn, Anorm=Anorm, Acond=Acond, rnorm=rnorm, Arnorm=Arnorm, ynorm=ynorm )
  !                                data=data_mres; modl=modl_mres
          elseif(mode==6)then 
                  write(*,*)'Starting Precond. CG inversion..............................'
                  !call solver_pre_cg(m=modl, d=data, Fop=conv_oper, Sop=conv_precon_oper , Jop=conv_mask_oper, niter=niter, rmov=rmov, mmov=mmov, jmov=jmov, norm=norm, verb=verb, tol=rtol)
  !                                data=data_mres; modl=modl_mres
          elseif(mode==7)then
                  write(*,*)'Starting Solver simpl..............................'
                  !call solver_smp(m=modl, d=data, Fop=conv_oper,  stepper=cgstep, niter=niter, rmov=rmov, mmov=mmov, verb=verb)
                  !call solver_reg_me(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper2, Wop=conv_weight_oper, stepper=cg_step, niter=niter, rmov=rmov, mmov=mmov, verb=verb, eps=eps, nAop=size(modl))
                  !call solver_precond1(m=modl, d=data, Fop=conv_oper, Pop=conv_precon_oper, niter=niter, r_mov=rmov, m_mov=mmov, r_nor=norm,beta_max=1.)
          elseif(mode==8)then
                  write(*,*)'Starting Solver cg square reg..............................'
                  !call solver_cg_square(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper2, niter=niter, jmov=jmov, rmov=rmov, mmov=mmov, norm=norm, verb=verb, eps=eps, tol=rtol)
          elseif(mode==9)then
                  write(*,*)'Starting Yaxuns solver..............................'
                  if(noreg) then
                      write(*,*)'No reg..............................' 
                      call solver_cg_smp(m=modl, d=data, Fop=conv_oper, search=.true.,  niter=niter, rmov=rmov, mmov=mmov) 
                     ! call base_solver_cglpd_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper2, eps=(0.*modl)+1., search=.true., Wop=conv_weight_oper, niter=niter, rmov=rmov, mmov=mmov)
                  else
                      write(*,*)'Reg..............................'
                     ! call base_solver_cglpd_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper2, eps=(0.*modl)+1., search=.true., Wop=conv_weight_oper, niter=niter, rmov=rmov, mmov=mmov)
                 endif
           elseif(mode==10)then
                     write(*,*)'yax+prc...........................'
                      call solver_cg_prc(m=modl, d=data, Fop=conv_oper, Sop=conv_precon_oper, search=.true., niter=niter, rmov=rmov, mmov=mmov, fmov=norm)
           elseif(mode==11)then
                     write(*,*)'yax+Time...........................'
                     call solver_cg_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_temp_oper, eps=epsi, search=.true., niter=niter, rmov=rmov, mmov=mmov)
           elseif(mode==12)then
                     write(*,*)'yax+Space.........................'
                     call solver_cg_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_oper, eps=epsi, search=.true., niter=niter, rmov=rmov, mmov=mmov)
           elseif(mode==13)then
                     write(*,*)'yax+time+Space.........................'
                     call solver_cg_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_temp_grad_oper, eps=epsi, search=.true., niter=niter, rmov=rmov, mmov=mmov)
           elseif(mode==14)then
                     write(*,*)'yax+Space+time.........................'
                     call solver_cg_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_grad_temp_oper, eps=epsi, search=.true., niter=niter, rmov=rmov, mmov=mmov)
           elseif(mode==15)then
                     write(*,*)"L'L+A1'A1+A2'A2........................."
                     call solver_cg_2reg(m=modl, d=data, Fop=conv_oper, Aop1=conv_grad_oper, Aop2=conv_temp_oper, eps1=epsi, eps2=lmbd, search=.true., niter=niter, rmov=rmov, mmov=mmov)
           elseif(mode==16)then
                     write(*,*)"L'L+A1'A1+A2'A2+++Wop........................."
                     call solver_cg_2reg(m=modl, d=data, Fop=conv_oper, Aop1=conv_grad_oper, Aop2=conv_temp_oper, Wop=conv_mask_oper, eps1=epsi, eps2=lmbd, search=.true., niter=niter, rmov=rmov, mmov=mmov)
           elseif(mode==17)then
                     write(*,*)'yax+damp.........................'; epsi=4.
                     call solver_cg_reg(m=modl, d=data, Fop=conv_oper, Aop=conv_damp_oper, eps=epsi, search=.true., niter=niter, rmov=rmov, mmov=mmov)
           elseif(mode==18)then 
                    epsi=80.
                    write(*,*)'hbgd+damp..morm_d,norm_m,eps',norm_d,norm_m,maxval(epsi)
                    call solver_reg_nrm(m=modl, d=data, Fop=conv_oper, Aop=conv_damp_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=maxval(epsi), & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F, nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T)
           elseif(mode==19)then 
                    write(0,'(A40,2A8,3g12.5)')'hbgd+dip..morm_d,norm_m,eps,qd,qm',norm_d,norm_m,maxval(epsi),quant_d,quant_m
                    call solver_reg_nrm(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_dips_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=maxval(epsi), & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F, nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T)
           elseif(mode==20)then 
                    write(0,'(A40,2A8,3g12.5)')'hbgd+dip+temp..morm_d,norm_m,eps,qd,qm',norm_d,norm_m,maxval(epsi),quant_d,quant_m
                    call solver_reg_nrm(m=modl, d=data, Fop=conv_oper, Aop=spatio_lop, stepper=cgstepper, nAop=2*size(modl), niter=niter, epsi=maxval(epsi), & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T)
           elseif(mode==21)then
                    write(0,'(A40,2A8,3g12.5)')'hbgd+dip+temp+leak..morm_d,norm_m,eps,qd,qm',norm_d,norm_m,maxval(epsi),quant_d,quant_m
                    call solver_reg_nrm(m=modl, d=data, Fop=conv_oper, Aop=spatio_int_lop, stepper=cgstepper, nAop=3*size(modl), niter=niter, epsi=maxval(epsi), & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T)
           elseif(mode==22)then
                    write(0,'(A40,2A8,3g12.5)')'hbgd+dip+temp+imp..morm_d,norm_m,eps,qd,qm',norm_d,norm_m,maxval(epsi),quant_d,quant_m
                    call solver_reg_nrm(m=modl, d=data, Fop=hessian_convolve_impedance_oper, Aop=spatio_grad_lop, stepper=cgstepper, nAop=3*size(modl), niter=niter, epsi=maxval(epsi), & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T)
           elseif(mode==23)then
                    write(0,'(A40,2A8,3g12.5)')'hbgd+dip+temp+imp..morm_d,norm_m,eps,qd,qm',norm_d,norm_m,maxval(epsi),quant_d,quant_m
                    call solver_reg_nrm(m=modl, d=data, Fop=hessian_convolve_impedance_oper, Aop=spatio_lop, stepper=cgstepper, nAop=2*size(modl), niter=niter, epsi=maxval(epsi), & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T)
           elseif(mode==24)then
                    write(0,'(A40,2A8,3g12.5)')'hbgd+dip+temp+leak+diag..morm_d,norm_m,eps,qd,qm',norm_d,norm_m,maxval(epsi),quant_d,quant_m
                    call solver_reg_nrm(m=modl, d=data, Fop=conv_oper, Aop=spatio_lop, stepper=cgstepper, nAop=3*size(modl), niter=niter, epsi=maxval(epsi), & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T)
           elseif(mode==25)then 
                    write(0,'(A70,I5)')'Mode: ',mode
                    write(0,'(A70,2A8,3g12.5)')'hbgd+dip+damp..morm_d,norm_m,eps1,eps2: ',norm_d,norm_m,eps1,eps2
                    write(0,'(A60,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4 : ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A60,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_dips_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=maxval(epsi), & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper, epsi1=maxval(epsi), &
                                nAop1=size(modl),nAop2=0,nAop3=0,nAop4=0, &
                                nm1_in=norm_m,nm2_in=norm_m,nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt1_mod_in=quant_m1,qnt2_mod_in=quant_m2,qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, & 
                                err=err)
           elseif(mode==26)then
                    write(0,'(A70,I5)')'Mode: ',mode
                    write(0,'(A70,2A8,3g12.5)')'hbgd+dip+damp..morm_d,norm_m,eps1,eps2: ',norm_d,norm_m,eps1,eps2
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4 : ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_dips_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper, epsi1=eps2, &
                                nAop1=size(modl),nAop2=0,nAop3=0,nAop4=0, &
                                nm1_in=norm_m,nm2_in=norm_m,nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt1_mod_in=quant_m1,qnt2_mod_in=quant_m2,qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, & 
                                err=err)
           elseif(mode==27)then
                    write(0,'(A70,I5)')'Mode: ',mode
                    write(0,'(A70,3g12.5)')'hbgd+dip+damp+(dip+leak)..eps1,epA1,epB1: ', eps1, epA1, epB1
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4: ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_dips_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper,         epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, & 
                                Aop2=spatial_impedance_oper, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, & 
                                nAop3=0,nAop4=0, &
                                nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, & 
                                err=err)
           elseif(mode==28)then
                    write(0,'(A70,I5)')'Mode: ',mode
                    write(0,'(A70,3g12.5)')'hbgd+dip+damp+(dip+leak)..eps1,epA1,epB1: ', eps1, epA1, epB1
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4: ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_dips_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper,         epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, & 
                                Aop2=spatial_impedance_oper, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, & 
                                nAop3=0,nAop4=0, &
                                nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, & 
                                err=err)
           elseif(mode==29)then
                    write(0,'(A70,3g12.5)')'hbgd+dip+damp+(dip+leak)..eps1,epA1,epB1: ', eps1, epA1, epB1
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4: ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_dips_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper             , epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, & 
                                Aop2=hessian_convolve_temp_oper1, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, & 
                                nAop3=0,nAop4=0, &
                                nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, & 
                                err=err)
           elseif(mode==30)then
                    write(0,'(A70,I5)')'Mode: ',mode
                    write(0,'(A70,3g12.5)')'hbgd+dip+damp+(dip+leak)..eps1,epA1,epB1: ', eps1, epA1, epB1
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4: ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_dips_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper            , epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, &
                                Aop2=hessian_convolve_temp_oper1, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, &
                                Aop3=spatial_diff_oper        , epsi3=epC1, nAop3=size(modl), nm3_in=norm_m, qnt3_mod_in=quant_m3, &
                                nAop4=0, &
                                nm4_in=norm_m4, &
                                qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, & 
                                err=err)
           elseif(mode==31)then
                    write(0,'(A70,I5)')'Mode: ',mode
                    write(0,'(A70,3g12.5)')'hbgd+dip+damp+(dip+leak)..eps1,epA1,epB1: ', eps1, epA1, epB1
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4: ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_vdips_oper_1var, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper             , epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, &
                                Aop2=hessian_convolve_temp_oper1, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, &
                                Aop3=vspatial_diff_oper         , epsi3=epC1, nAop3=size(modl), nm3_in=norm_m, qnt3_mod_in=quant_m3, &
                                nAop4=0, &
                                nm4_in=norm_m4, &
                                qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, & 
                                err=err)
           elseif(mode==32)then
                    write(0,'(A70,I5)')'Mode: ',mode
                    write(0,'(A70,5g12.5)')'hbgd+dip+damp+(dip+leak)..eps1,epA1,epB1, epC1, epD1: ', eps1, epA1, epB1, epC1, epD1
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4: ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
!                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_vdips_oper_1var, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_vdips_oper_1var, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper             , epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, &
                                Aop2=hessian_convolve_temp_oper1, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, &
                                Aop3=vspatial_diff_oper         , epsi3=epC1, nAop3=size(modl), nm3_in=norm_m, qnt3_mod_in=quant_m3, &
                                Aop4=vspatial_diff_oper_smth    , epsi4=epD1, nAop4=size(modl), nm4_in=norm_m, qnt4_mod_in=quant_m4, &
                                verb_quant_in=F, &
                                report_in=report_, &  
                                err=err)
!start over
!start over
           elseif(mode==33)then
                    write(0,'(A30,I5,A15)')'Mode: ',mode,'only damping'
                    write(0,'(A30,5g12.5)')'hbgd+damp..eps1,epA1:', eps1
                    write(0,'(A30,10(A8,5X))')'norm_d, norm_m:',norm_d ,norm_m 
                    write(0,'(A30,10g12.5  )')'quant_d,qunat_m:',quant_d,quant_m
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=conv_damp_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                nAop1=0,nAop2=0,nAop3=0,nAop4=0, &
                                nm1_in=norm_m,nm2_in=norm_m,nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt1_mod_in=quant_m1,qnt2_mod_in=quant_m2,qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, & 
                                mmov_=mmov_, rdov_=rdov_, jmov=jmov, &
                                err=err)
           elseif(mode==34)then
                    write(0,'(A30,I5,A15)')'Mode: ',mode,'only integ-z'
                    write(0,'(A30,5g12.5)')'hbgd+damp..eps1,epA1:', eps1
                    write(0,'(A30,10(A8,5X))')'norm_d, norm_m:',norm_d ,norm_m 
                    write(0,'(A30,10g12.5  )')'quant_d,qunat_m:',quant_d,quant_m
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_leak_oper, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                nAop1=0,nAop2=0,nAop3=0,nAop4=0, &
                                nm1_in=norm_m,nm2_in=norm_m,nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt1_mod_in=quant_m1,qnt2_mod_in=quant_m2,qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, &
                                mmov_=mmov_, rdov_=rdov_, jmov=jmov, &
                                err=err)
           elseif(mode==35)then
                    write(0,'(A30,I5,A15)')'Mode: ',mode,'only dips'
                    write(0,'(A30,5g12.5)')'hbgd+damp..eps1,epA1:', eps1
                    write(0,'(A30,10(A8,5X))')'norm_d, norm_m:',norm_d ,norm_m 
                    write(0,'(A30,10g12.5  )')'quant_d,qunat_m:',quant_d,quant_m
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_vdips_oper_1var, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                nAop1=0,nAop2=0,nAop3=0,nAop4=0, &
                                nm1_in=norm_m,nm2_in=norm_m,nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt1_mod_in=quant_m1,qnt2_mod_in=quant_m2,qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, &
                                mmov_=mmov_, rdov_=rdov_, jmov=jmov, &
                                err=err)
           elseif(mode==36)then
                    write(0,'(A70,I5,A15)')'Mode: ',mode, 'dips+damp'
                    write(0,'(A70,5g12.5)')'hbgd+dip+damp..eps1,epA1,epB1, epC1, epD1: ', eps1, epA1, epB1, epC1, epD1
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4 : ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_vdips_oper_1var, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper             , epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, &
                                nAop2=0,nAop3=0,nAop4=0, &
                                nm2_in=norm_m,nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt2_mod_in=quant_m2,qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, &
                                mmov_=mmov_, rdov_=rdov_, jmov=jmov, &
                                err=err)
           elseif(mode==37)then
                    write(0,'(A70,I5,A15)')'Mode: ',mode, 'dips+damp+diff'
                    write(0,'(A70,5g12.5)')'hbgd+dip+damp..eps1,epA1,epB1, epC1, epD1: ', eps1, epA1, epB1, epC1, epD1
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4 : ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_vdips_oper_1var, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper             , epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, &
                                Aop2=hessian_convolve_temp_oper1, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, &
                                nAop3=0,nAop4=0, &
                                nm3_in=norm_m3,nm4_in=norm_m4, &
                                qnt3_mod_in=quant_m3,qnt4_mod_in=quant_m4,&
                                verb_quant_in=F, &
                                report_in=report_, &
                                mmov_=mmov_, rdov_=rdov_, jmov=jmov, &
                                err=err)
           elseif(mode==38)then
                    write(0,'(A70,I5,A15)')'Mode: ',mode, 'dips+damp+diff'
                    write(0,'(A70,5g12.5)')'lmb1---temp rat to spat', lmd1
                    write(0,'(A70,5g12.5)')'hbgd+dip+damp..eps1,epA1,epB1, epC1, epD1: ', &                    
                    eps1/sqrt(dot_product(data,data)),&
                    epA1/sqrt(dot_product(data,data)),&
                    epB1/sqrt(dot_product(data,data)),&
                    epC1/sqrt(dot_product(data,data)),&
                    epD1/sqrt(dot_product(data,data))
                    write(0,'(A70,10(A8,5X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4 : ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_vdips_oper_1var, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper             , epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, &
                                Aop2=hessian_convolve_temp_oper2, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, &
                                Aop3=vspatial_diff_oper2    , epsi3=epC1, nAop3=size(modl), nm3_in=norm_m, qnt3_mod_in=quant_m3, &
                                Aop4=vspatial_diff_oper3_smth   , epsi4=epD1, nAop4=size(modl), nm4_in=norm_m, qnt4_mod_in=quant_m4, &
                                verb_quant_in=F, &
                                report_in=report_, &
                                mmov_=mmov_, rdov_=rdov_, jmov=jmov, &
                                err=err)
           elseif(mode==39)then
                    write(0,'(A70,I5,A15)')'Mode: ',mode, 'dips+damp+diff'
                    write(0,'(A70,5g12.5)')'lmb1---temp rat to spat', lmd1
                    write(0,'(A70,5g12.5)')'hbgd+dip+damp..eps1,epA1,epB1, epC1, epD1: ', &                    
                    eps1/sqrt(dot_product(data,data)),&
                    epA1/sqrt(dot_product(data,data)),&
                    epB1/sqrt(dot_product(data,data)),&
                    epC1/sqrt(dot_product(data,data)),&
                    epD1/sqrt(dot_product(data,data))
                    write(0,'(A70,10(A10,2X))')'norm_d, norm_m, norm_m1, norm_m2, norm_m3, norm_m4 : ',norm_d ,norm_m ,norm_m1 ,norm_m2 ,norm_m3 ,norm_m4
                    write(0,'(A70,10g12.5)')'quant_d,qunat_m,qunat_m1,qunat_m2,qunat_m3,qunat_m4: ',quant_d,quant_m,quant_m1,quant_m2,quant_m3,quant_m4
                    call solver_hybrid(m=modl, d=data, Fop=conv_oper, Aop=hessian_convolve_vdips_oper_1var, stepper=cgstepper, nAop=size(modl), niter=niter, epsi=eps1, & 
                                norm_dat_in=norm_d, norm_mod_in=norm_m, qnt_dat_in=quant_d, qnt_mod_in=quant_m, qt_period_in=quant_period, psiter=psiter, overshot_shrink_max_cnt_in=max_overshot, &
                                time_in=T, spatio_in=F,nreg=size(modl), ndat=size(data)*nsurv, break_reg=T, comb_reg=T, verb=T, &
                                Aop1=conv_damp_oper             , epsi1=epA1, nAop1=size(modl), nm1_in=norm_m, qnt1_mod_in=quant_m1, &
                                Aop2=hessian_convolve_temp_oper3, epsi2=epB1, nAop2=size(modl), nm2_in=norm_m, qnt2_mod_in=quant_m2, &
                                Aop3=vspatial_diff_oper_4dsmth  , epsi3=epC1, nAop3=size(modl), nm3_in=norm_m, qnt3_mod_in=quant_m3, &
                                Aop4=vspatial_diff_oper3_smth   , epsi4=epD1, nAop4=size(modl), nm4_in=norm_m, qnt4_mod_in=quant_m4, &
                                verb_quant_in=F, &
                                report_in=report_, &
                                mmov_=mmov_, rdov_=rdov_, jmov=jmov, &
                                err=err)
          else  
              call seperr('You have not selected an inversion scheme...')
          endif

 else
                stat = conv_oper(adj , .false., modl, data)
 endif
 call hessian_conv_output()
 stat = conv_clos()
 call date_and_time(values=time_array_4)
 finish_t = time_array_4 (5) * 3600 + time_array_4 (6) * 60 + time_array_4 (7) + 0.001 * time_array_4 (8)
 write(0,*)'TOTAL TIME FOR INVERSION', (finish_t - start_t)/60,trim('mins')
 if(exist_file(err_))write(11,'(g15.4)')err
 !write(0,*)'TOTAL TIME FOR INVERSION', finish_t - start_t
 !write(0,*)'TOTAL TIME FOR INVERSION:', time_array_4 (5) - time_array_3 (5),trim(':'),time_array_4 (6)-time_array_3 (6),trim(';'),time_array_4 (7)-time_array_3 (7),trim('.'),time_array_4 (8)-time_array_3 (8)
 
 stat=vns_clos()
 end program
