module hessian_convolve_add
 use hessian_convolve_params
 
 implicit none

 contains  
!#####################################################  
  subroutine hessian_conv_add(adj,add,modl,data)
  logical            :: adj, add
  real, dimension(:) :: modl, data

  if (.not. add )then
      if (adj)then;  
         if (nsurv > 5) then; 
            modl(0*nmod+1:1*nmod)=modl1;        modl(1*nmod+1:2*nmod)=modl2;
            modl(2*nmod+1:3*nmod)=modl3;        modl(3*nmod+1:4*nmod)=modl4;
            modl(4*nmod+1:5*nmod)=modl5;        modl(5*nmod+1:6*nmod)=modl6
         elseif (nsurv > 4) then; 
            modl(0*nmod+1:1*nmod)=modl1;        modl(1*nmod+1:2*nmod)=modl2;
            modl(2*nmod+1:3*nmod)=modl3;        modl(3*nmod+1:4*nmod)=modl4;
            modl(4*nmod+1:5*nmod)=modl5;
         elseif (nsurv > 3) then; 
            modl(0*nmod+1:1*nmod)=modl1;        modl(1*nmod+1:2*nmod)=modl2;
            modl(2*nmod+1:3*nmod)=modl3;        modl(3*nmod+1:4*nmod)=modl4;
         elseif (nsurv > 2) then; 
            modl(0*nmod+1:1*nmod)=modl1;        modl(1*nmod+1:2*nmod)=modl2;
            modl(2*nmod+1:3*nmod)=modl3;
         elseif (nsurv > 1) then; 
            modl(0*nmod+1:1*nmod)=modl1;        modl(1*nmod+1:2*nmod)=modl2;
         elseif (nsurv > 0) then; 
            modl(0*nmod+1:1*nmod)=modl1;
        endif
     else
         if (nsurv > 5) then; 
            data(0*nmod+1:1*nmod)=data1;        data(1*nmod+1:2*nmod)=data2;
            data(2*nmod+1:3*nmod)=data3;        data(3*nmod+1:4*nmod)=data4;
            data(4*nmod+1:5*nmod)=data5;        data(5*nmod+1:6*nmod)=data6
         elseif (nsurv > 4) then;
            data(0*nmod+1:1*nmod)=data1;        data(1*nmod+1:2*nmod)=data2;
            data(2*nmod+1:3*nmod)=data3;        data(3*nmod+1:4*nmod)=data4;
            data(4*nmod+1:5*nmod)=data5;
         elseif (nsurv > 3) then; 
            data(0*nmod+1:1*nmod)=data1;        data(1*nmod+1:2*nmod)=data2;
            data(2*nmod+1:3*nmod)=data3;        data(3*nmod+1:4*nmod)=data4;
         elseif (nsurv > 2) then; 
            data(0*nmod+1:1*nmod)=data1;        data(1*nmod+1:2*nmod)=data2;
            data(2*nmod+1:3*nmod)=data3;
         elseif (nsurv > 1) then; 
            data(0*nmod+1:1*nmod)=data1;        data(1*nmod+1:2*nmod)=data2;
         elseif (nsurv > 0) then; 
            data(0*nmod+1:1*nmod)=data1;
        endif
     endif
  else
      if (adj)then;  
         if (nsurv > 5) then; 
            modl(0*nmod+1:1*nmod)=modl(0*nmod+1:1*nmod)+modl1;            modl(1*nmod+1:2*nmod)=modl(1*nmod+1:2*nmod)+modl2;
            modl(2*nmod+1:3*nmod)=modl(2*nmod+1:3*nmod)+modl3;            modl(3*nmod+1:4*nmod)=modl(3*nmod+1:4*nmod)+modl4;
            modl(4*nmod+1:5*nmod)=modl(4*nmod+1:5*nmod)+modl5;            modl(5*nmod+1:6*nmod)=modl(5*nmod+1:6*nmod)+modl6;
         elseif (nsurv > 4) then;
            modl(0*nmod+1:1*nmod)=modl(0*nmod+1:1*nmod)+modl1;            modl(1*nmod+1:2*nmod)=modl(1*nmod+1:2*nmod)+modl2;
            modl(2*nmod+1:3*nmod)=modl(2*nmod+1:3*nmod)+modl3;            modl(3*nmod+1:4*nmod)=modl(3*nmod+1:4*nmod)+modl4;
            modl(4*nmod+1:5*nmod)=modl(4*nmod+1:5*nmod)+modl5;
         elseif (nsurv > 3) then; 
            modl(0*nmod+1:1*nmod)=modl(0*nmod+1:1*nmod)+modl1;            modl(1*nmod+1:2*nmod)=modl(1*nmod+1:2*nmod)+modl2;
            modl(2*nmod+1:3*nmod)=modl(2*nmod+1:3*nmod)+modl3;            modl(3*nmod+1:4*nmod)=modl(3*nmod+1:4*nmod)+modl4;
         elseif (nsurv > 2) then; 
            modl(0*nmod+1:1*nmod)=modl(0*nmod+1:1*nmod)+modl1;            modl(1*nmod+1:2*nmod)=modl(1*nmod+1:2*nmod)+modl2;
            modl(2*nmod+1:3*nmod)=modl(2*nmod+1:3*nmod)+modl3;
         elseif (nsurv > 1) then; 
            modl(0*nmod+1:1*nmod)=modl(0*nmod+1:1*nmod)+modl1;            modl(1*nmod+1:2*nmod)=modl(1*nmod+1:2*nmod)+modl2;
         elseif (nsurv > 0) then; 
            modl(0*nmod+1:1*nmod)=modl(0*nmod+1:1*nmod)+modl1;
        endif
     else
         if (nsurv > 5) then; 
            data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data1;            data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data2;
            data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data3;            data(3*nmod+1:4*nmod)=data(3*nmod+1:4*nmod)+data4;
            data(4*nmod+1:5*nmod)=data(4*nmod+1:5*nmod)+data5;            data(5*nmod+1:6*nmod)=data(5*nmod+1:6*nmod)+data6;
         elseif (nsurv > 4) then;
            data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data1;            data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data2;
            data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data3;            data(3*nmod+1:4*nmod)=data(3*nmod+1:4*nmod)+data4;
            data(4*nmod+1:5*nmod)=data(4*nmod+1:5*nmod)+data5;
         elseif (nsurv > 3) then; 
            data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data1;            data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data2;
            data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data3;            data(3*nmod+1:4*nmod)=data(3*nmod+1:4*nmod)+data4;
         elseif (nsurv > 2) then; 
            data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data1;            data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data2;
            data(2*nmod+1:3*nmod)=data(2*nmod+1:3*nmod)+data3;
         elseif (nsurv > 1) then; 
            data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data1;            data(1*nmod+1:2*nmod)=data(1*nmod+1:2*nmod)+data2;
         elseif (nsurv > 0) then; 
            data(0*nmod+1:1*nmod)=data(0*nmod+1:1*nmod)+data1;
        endif
     endif

  endif
  end subroutine
end module
