module hessian_convolve_io
 use hessian_convolve_params
 implicit none

contains
!#######
 subroutine hessian_conv_output()
 if (adj .or. inv) then
        if (nsurv > 5) then
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);modl3=modl(2*nmod+1:3*nmod);modl4=modl(3*nmod+1:4*nmod);modl5=modl(4*nmod+1:5*nmod);modl6=modl(5*nmod+1:6*nmod)
            call sep_write(modl1, modl1_); call sep_write(modl2, modl2_); call sep_write(modl3, modl3_); call sep_write(modl4, modl4_); call sep_write(modl5, modl5_); call sep_write(modl6, modl6_);
!            mmov1=mmov(0*nmod+1:1*nmod,:); mmov2=mmov(1*nmod+1:2*nmod,:); mmov3=mmov(2*nmod+1:3*nmod,:); mmov4=mmov(3*nmod+1:4*nmod,:); mmov5=mmov(4*nmod+1:5*nmod,:); mmov6=mmov(5*nmod+1:6*nmod,:); 
!            rmov1=rmov(0*nmod+1:1*nmod,:); rmov2=rmov(1*nmod+1:2*nmod,:); rmov3=rmov(2*nmod+1:3*nmod,:); rmov4=rmov(3*nmod+1:4*nmod,:); rmov5=rmov(4*nmod+1:5*nmod,:); rmov6=rmov(5*nmod+1:6*nmod,:); 
!            norm1=sum(abs(rmov1),1); norm2=sum(abs(rmov2),1); norm3=sum(abs(rmov3),1); norm4=sum(abs(rmov4),1); norm5=sum(abs(rmov5),1); norm6=sum(abs(rmov6),1);
!            call sep_write(mmov1, mmov1_); call sep_write(mmov2, mmov2_);call sep_write(mmov3, mmov3_); call sep_write(mmov4, mmov4_);call sep_write(mmov5, mmov5_); call sep_write(mmov6, mmov6_);
!            call sep_write(rmov1, rmov1_); call sep_write(rmov2, rmov2_);call sep_write(rmov3, rmov3_); call sep_write(rmov4, rmov4_);call sep_write(rmov5, rmov5_); call sep_write(rmov6, rmov6_);
!            call sep_write(norm1, norm1_); call sep_write(norm2, norm2_);call sep_write(norm3, norm3_); call sep_write(norm4, norm4_);call sep_write(norm5, norm5_); call sep_write(norm6, norm6_);
        elseif (nsurv > 4) then
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);modl3=modl(2*nmod+1:3*nmod);modl4=modl(3*nmod+1:4*nmod);modl5=modl(4*nmod+1:5*nmod);
            call sep_write(modl1, modl1_); call sep_write(modl2, modl2_); call sep_write(modl3, modl3_); call sep_write(modl4, modl4_); call sep_write(modl5, modl5_);  
!            mmov1=mmov(0*nmod+1:1*nmod,:); mmov2=mmov(1*nmod+1:2*nmod,:); mmov3=mmov(2*nmod+1:3*nmod,:); mmov4=mmov(3*nmod+1:4*nmod,:); mmov5=mmov(4*nmod+1:5*nmod,:);
!            rmov1=rmov(0*nmod+1:1*nmod,:); rmov2=rmov(1*nmod+1:2*nmod,:); rmov3=rmov(2*nmod+1:3*nmod,:); rmov4=rmov(3*nmod+1:4*nmod,:); rmov5=rmov(4*nmod+1:5*nmod,:); 
!            norm1=sum(abs(rmov1),1); norm2=sum(abs(rmov2),1); norm3=sum(abs(rmov3),1); norm4=sum(abs(rmov4),1); norm5=sum(abs(rmov5),1); 
!            call sep_write(mmov1, mmov1_); call sep_write(mmov2, mmov2_);call sep_write(mmov3, mmov3_); call sep_write(mmov4, mmov4_);call sep_write(mmov5, mmov5_); 
!            call sep_write(rmov1, rmov1_); call sep_write(rmov2, rmov2_);call sep_write(rmov3, rmov3_); call sep_write(rmov4, rmov4_);call sep_write(rmov5, rmov5_); 
!            call sep_write(norm1, norm1_); call sep_write(norm2, norm2_);call sep_write(norm3, norm3_); call sep_write(norm4, norm4_);call sep_write(norm5, norm5_); 
         elseif (nsurv > 3) then
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);modl3=modl(2*nmod+1:3*nmod);modl4=modl(3*nmod+1:4*nmod);
            call sep_write(modl1, modl1_); call sep_write(modl2, modl2_); call sep_write(modl3, modl3_); call sep_write(modl4, modl4_);  
!            mmov1=mmov(0*nmod+1:1*nmod,:); mmov2=mmov(1*nmod+1:2*nmod,:); mmov3=mmov(2*nmod+1:3*nmod,:); mmov4=mmov(3*nmod+1:4*nmod,:); 
!            rmov1=rmov(0*nmod+1:1*nmod,:); rmov2=rmov(1*nmod+1:2*nmod,:); rmov3=rmov(2*nmod+1:3*nmod,:); rmov4=rmov(3*nmod+1:4*nmod,:); 
!            norm1=sum(abs(rmov1),1); norm2=sum(abs(rmov2),1); norm3=sum(abs(rmov3),1); norm4=sum(abs(rmov4),1); 
!            call sep_write(mmov1, mmov1_); call sep_write(mmov2, mmov2_);call sep_write(mmov3, mmov3_); call sep_write(mmov4, mmov4_);
!            call sep_write(rmov1, rmov1_); call sep_write(rmov2, rmov2_);call sep_write(rmov3, rmov3_); call sep_write(rmov4, rmov4_);
!            call sep_write(norm1, norm1_); call sep_write(norm2, norm2_);call sep_write(norm3, norm3_); call sep_write(norm4, norm4_);
        elseif (nsurv > 2) then
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);modl3=modl(2*nmod+1:3*nmod);
            call sep_write(modl1, modl1_); call sep_write(modl2, modl2_); call sep_write(modl3, modl3_);  
!            mmov1=mmov(0*nmod+1:1*nmod,:); mmov2=mmov(1*nmod+1:2*nmod,:); mmov3=mmov(2*nmod+1:3*nmod,:); 
!            rmov1=rmov(0*nmod+1:1*nmod,:); rmov2=rmov(1*nmod+1:2*nmod,:); rmov3=rmov(2*nmod+1:3*nmod,:); 
!            norm1=sum(abs(rmov1),1); norm2=sum(abs(rmov2),1); norm3=sum(abs(rmov3),1);
!            call sep_write(mmov1, mmov1_); call sep_write(mmov2, mmov2_);call sep_write(mmov3, mmov3_); 
!            call sep_write(rmov1, rmov1_); call sep_write(rmov2, rmov2_);call sep_write(rmov3, rmov3_); 
!            call sep_write(norm1, norm1_); call sep_write(norm2, norm2_);call sep_write(norm3, norm3_); 
        elseif (nsurv > 1) then
            modl1=modl(0*nmod+1:1*nmod);modl2=modl(1*nmod+1:2*nmod);
            call sep_write(modl1, modl1_); call sep_write(modl2, modl2_);  
!            mmov1=mmov(0*nmod+1:1*nmod,:); mmov2=mmov(1*nmod+1:2*nmod,:); 
!            rmov1=rmov(0*nmod+1:1*nmod,:); rmov2=rmov(1*nmod+1:2*nmod,:); 
!            norm1=sum(abs(rmov1),1); norm2=sum(abs(rmov2),1); 
!            call sep_write(mmov1, mmov1_); call sep_write(mmov2, mmov2_);
!            call sep_write(rmov1, rmov1_); call sep_write(rmov2, rmov2_);
!            call sep_write(norm1, norm1_); call sep_write(norm2, norm2_);
        elseif (nsurv > 0) then
            modl1=modl(0*nmod+1:1*nmod);
            call sep_write(modl1, modl1_);
!            mmov1=mmov(0*nmod+1:1*nmod,:); 
!            rmov1=rmov(0*nmod+1:1*nmod,:); 
!            norm1=sum(abs(rmov1),1); 
!            call sep_write(mmov1, mmov1_); 
!            call sep_write(rmov1, rmov1_); 
!            call sep_write(norm1, norm1_); 
         endif
  else
        if (nsurv > 5) then
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);data3=data(2*nmod+1:3*nmod);data4=data(3*nmod+1:4*nmod);data5=data(4*nmod+1:5*nmod);data6=data(5*nmod+1:6*nmod)
            call sep_write(data1, data1_); call sep_write(data2, data2_); call sep_write(data3, data3_); call sep_write(data4, data4_); call sep_write(data5, data5_); call sep_write(data6, data6_); 
        elseif (nsurv > 4) then
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);data3=data(2*nmod+1:3*nmod);data4=data(3*nmod+1:4*nmod);data5=data(4*nmod+1:5*nmod);
            call sep_write(data1, data1_); call sep_write(data2, data2_); call sep_write(data3, data3_); call sep_write(data4, data4_); call sep_write(data5, data5_); 
        elseif (nsurv > 3) then
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);data3=data(2*nmod+1:3*nmod);data4=data(3*nmod+1:4*nmod);
            call sep_write(data1, data1_); call sep_write(data2, data2_); call sep_write(data3, data3_); call sep_write(data4, data4_); 
        elseif (nsurv > 2) then
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);data3=data(2*nmod+1:3*nmod);
            call sep_write(data1, data1_); call sep_write(data2, data2_); call sep_write(data3, data3_); 
        elseif (nsurv > 1) then
            data1=data(0*nmod+1:1*nmod);data2=data(1*nmod+1:2*nmod);
            call sep_write(data1, data1_); call sep_write(data2, data2_); 
        elseif (nsurv > 0) then
            call sep_write(data1, data1_); 
            data1=data(0*nmod+1:1*nmod);
        endif
  endif
  end subroutine
!###################################  
  subroutine hess_io(hess, hgrid, ix_modl, iy_modl, iz_modl, file_, flag)
    real, dimension(:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , 1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1               , 1               , 1              , 1              , 1              /)
    f_wind = (/0               , 0               , 0              , 0              , 0              , 0               , 0               , ix_modl-1      , iy_modl-1      , iz_modl-1      /)
!    write(*,*)'--'; write(0,'(11(I5,2X))')n_cube; write(0,'(11(I5,2X))')n_wind; write(0,'(11(I5,2X))')j_wind; write(0,'(11(I5,2X))')f_wind
    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
!    write(0,*)sum(hess)
    
    return
  end subroutine
!###################  
  subroutine hess_io2(hess, hgrid, file_, flag)
    real, dimension(:,:,:,:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , 1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1               , 1               , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    f_wind = (/0               , 0               , 0              , 0              , 0              , 0               , 0               , 0              , 0              , 0              /)
!    write(*,*)'--'; write(0,'(11(I5,2X))')n_cube; write(0,'(11(I5,2X))')n_wind; write(0,'(11(I5,2X))')j_wind; write(0,'(11(I5,2X))')f_wind

    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
    write(0,*)sum(hess)
    return
  end subroutine
!###################  
  subroutine hess_io3(hessian, hgrid, iz_modl, file_, flag)
    real, dimension(:,:,:,:,:) :: hessian
    type(hes_grid)             :: hgrid
    integer                    :: ix_modl, iy_modl, iz_modl
    character(len=*)           :: file_
    character(len=4)           :: flag
    integer, dimension(10)     :: n_cube, j_wind, n_wind, f_wind
    integer                    :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , 1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1               , 1               , hgrid%ax_modl%n, hgrid%ay_modl%n, 1              /)
    f_wind = (/0               , 0               , 0              , 0              , 0              , 0               , 0               , 0              , 0              , iz_modl-1      /)
!    write(*,*)'--'; write(0,'(11(I5,2X))')n_cube; write(0,'(11(I5,2X))')n_wind; write(0,'(11(I5,2X))')j_wind; write(0,'(11(I5,2X))')f_wind
    !write(0,*)size(hessian,1),size(hessian,2),size(hessian,3),size(hessian,4),size(hessian,5)
    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hessian = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    end if
!    write(0,*)sum(hess)
    return
  end subroutine
!###################  
  subroutine hess_io4(hessian, hgrid, file_, flag)
    real, dimension(:,:,:,:,:,:):: hessian
    type(hes_grid)             	:: hgrid
    integer                    	:: ix_modl, iy_modl, iz_modl
    character(len=*)           	:: file_
    character(len=4)           	:: flag
    integer, dimension(10)     	:: n_cube, j_wind, n_wind, f_wind 
    integer                    	:: n_dim_cube, err
    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , 1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1               , 1               , hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    f_wind = (/0               , 0               , 0              , 0              , 0              , 0               , 0               , 0              , 0              , 0	           /)
!    write(*,*)'--'; write(0,'(11(I5,2X))')n_cube; write(0,'(11(I5,2X))')n_wind; write(0,'(11(I5,2X))')j_wind; write(0,'(11(I5,2X))')f_wind
!    write(0,*)size(hessian,1),size(hessian,2),size(hessian,3),size(hessian,4),size(hessian,5),size(hessian,6)
    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hessian = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hessian)
    end if
!    write(0,*)sum(hess)
    return
  end subroutine
!###################  
  subroutine hess_io_diag(hess, hgrid, file_, flag)
    real, dimension(:,:,:) :: hess
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(10) :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n  , hgrid%ay_offd%n  , hgrid%az_offd%n  , hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n  , hgrid%ay_modl%n  , hgrid%az_modl%n  /)
    j_wind = (/1               , 1               , 1                , 1                , 1                , 1               , 1               , 1                , 1                , 1                /)
    n_wind = (/1               , 1               , 1                , 1                , 1                , 1               , 1               , hgrid%ax_modl%n  , hgrid%ay_modl%n  , hgrid%az_modl%n  /)
    f_wind = (/0               , 0               , hgrid%ax_offd%n/2, hgrid%ay_offd%n/2, hgrid%az_offd%n-1, 0               , 0               , 0                , 0                , 0                /)
!    write(*,*)'--'; write(0,'(11(I5,2X))')n_cube; write(0,'(11(I5,2X))')n_wind; write(0,'(11(I5,2X))')j_wind; write(0,'(11(I5,2X))')f_wind

    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
!      write(0,*) 'In predonditioner ==> diagonal hessian....'
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
    return
  end subroutine
!###################################  
  subroutine hess_io_iz(hess, hgrid, iz_modl, file_, flag)
    real, dimension(:,:,:,:,:) :: hess
    type(hes_grid)             :: hgrid
    integer                    :: iz_modl
    character(len=*)           :: file_
    character(len=4)           :: flag
    integer, dimension(10)     :: n_cube, j_wind, n_wind, f_wind
    integer                    :: n_dim_cube, err

    n_dim_cube = 10
    n_cube = (/hgrid%ahx_offd%n, hgrid%ahy_offd%n, hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, hgrid%ahx_modl%n, hgrid%ahy_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n, hgrid%az_modl%n/)
    j_wind = (/1               , 1               , 1              , 1              , 1              , 1               , 1               , 1              , 1              , 1              /)
    n_wind = (/1               , 1               , hgrid%ax_offd%n, hgrid%ay_offd%n, hgrid%az_offd%n, 1               , 1               , hgrid%ax_modl%n, hgrid%ay_modl%n, 1              /)
    f_wind = (/0               , 0               , 0              , 0              , 0              , 0               , 0               , 0              , 0              , iz_modl-1      /)
!    write(*,*)'--'; write(0,'(11(I5,2X))')n_cube; write(0,'(11(I5,2X))')n_wind; write(0,'(11(I5,2X))')j_wind; write(0,'(11(I5,2X))')f_wind
    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    else if (flag == "reed") then
       hess = 0.
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,hess)
    end if
!    write(0,*)sum(hess)
    
    return
  end subroutine
!###################  
  subroutine weight_io(weight, hgrid, file_, flag)
    real, dimension(:,:,:) :: weight
    type(hes_grid)         :: hgrid
    integer                :: ix_modl, iy_modl, iz_modl
    character(len=*)       :: file_
    character(len=4)       :: flag
    integer, dimension(3)  :: n_cube, j_wind, n_wind, f_wind
    integer                :: n_dim_cube, err

    n_dim_cube = 3
    n_cube = (/hgrid%az_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n/)
    j_wind = (/1              , 1              , 1              /)
    n_wind = (/hgrid%az_modl%n, hgrid%ax_modl%n, hgrid%ay_modl%n/)
    f_wind = (/0              , 0              , 0              /)

!    write(*,*)'--'; write(0,'(11(I5,2X))')n_cube; write(0,'(11(I5,2X))')n_wind; write(0,'(11(I5,2X))')j_wind; write(0,'(11(I5,2X))')f_wind
    if (flag == "rite") then
    !   err = srite_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,wieght)
    else if (flag == "reed") then
       weight = 0.
       write(0,*) 'Weights ==> ....'
       write(0,*)size(weight,1),size(weight,2), size(weight,3),file_
       err = sreed_window(file_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,4,weight)
    end if
    return
  end subroutine
!###################  
  subroutine hessian_init()
        if(method==1)then
                if(nsurv>0)then;call hess_io4(he1, hgrid, hess1_, "reed"); HE_1=he1; endif
                if(nsurv>1)then;call hess_io4(he2, hgrid, hess2_, "reed"); HE_1=he1+he2                ; HE_2=he2; endif   
                if(nsurv>2)then;call hess_io4(he3, hgrid, hess3_, "reed"); HE_1=he1+he2+he3            ; HE_2=he2+he3            ;HE_3=he3 ; endif
                if(nsurv>3)then;call hess_io4(he4, hgrid, hess4_, "reed"); HE_1=he1+he2+he3+he4        ; HE_2=he2+he3+he4        ;HE_3=he3+he4        ;HE_4=he4; endif
                if(nsurv>4)then;call hess_io4(he5, hgrid, hess5_, "reed"); HE_1=he1+he2+he3+he4+he5    ; HE_2=he2+he3+he4+he5    ;HE_3=he3+he4+he5    ;HE_4=he4+he5    ;HE_5=he5; endif
                if(nsurv>5)then;call hess_io4(he6, hgrid, hess6_, "reed"); HE_1=he1+he2+he3+he4+he5+he6; HE_2=he2+he3+he4+he5+he6;HE_3=he3+he4+he5+he6;HE_4=he4+he5+he6;HE_5=he5+he6; HE_6=he6; endif
        else
                if(nsurv>0)then;call hess_io4(he1, hgrid, hess1_, "reed"); HE_1=he1; endif;
                if(nsurv>1)then;call hess_io4(he2, hgrid, hess2_, "reed"); HE_2=he2; endif;
                if(nsurv>2)then;call hess_io4(he3, hgrid, hess3_, "reed"); HE_3=he3; endif;
                if(nsurv>3)then;call hess_io4(he4, hgrid, hess4_, "reed"); HE_4=he4; endif;
                if(nsurv>4)then;call hess_io4(he5, hgrid, hess5_, "reed"); HE_5=he5; endif;
                if(nsurv>5)then;call hess_io4(he6, hgrid, hess6_, "reed"); HE_6=he6; endif;
        endif
  end subroutine



end module

