module hessian_convolve_param
use hessian_convolve_params

    contains
!==========================================================================================
  subroutine hessian_conv_params_init()
          mmov_ = "mmov";rmov_ = "rmov";rdov_ = "rdov";
          modl1_ = "modl1"; data1_ = "data1"; hess1_ = "hess1"; hesp1_ = "hesp1"; mmov1_ = "mmov1"; rmov1_ = "rmov1"; norm1_ ="norm1" ; wght1_ = "wg1"; mask1_ = "mask1"; epsi1_="epsi1"; lmbd1_="lmbd1"; pick1_ = "pick1"; 
          modl2_ = "modl2"; data2_ = "data2"; hess2_ = "hess2"; hesp2_ = "hesp2"; mmov2_ = "mmov2"; rmov2_ = "rmov2"; norm2_ ="norm2" ; wght2_ = "wg2"; mask2_ = "mask2"; epsi2_="epsi2"; lmbd2_="lmbd2"; pick2_ = "pick2"; 
          modl3_ = "modl3"; data3_ = "data3"; hess3_ = "hess3"; hesp3_ = "hesp3"; mmov3_ = "mmov3"; rmov3_ = "rmov3"; norm3_ ="norm3" ; wght3_ = "wg3"; mask3_ = "mask3"; epsi3_="epsi3"; lmbd3_="lmbd3"; pick3_ = "pick3"; 
          modl4_ = "modl4"; data4_ = "data4"; hess4_ = "hess4"; hesp4_ = "hesp4"; mmov4_ = "mmov4"; rmov4_ = "rmov4"; norm4_ ="norm4" ; wght4_ = "wg4"; mask4_ = "mask4"; epsi4_="epsi4"; lmbd4_="lmbd4"; pick4_ = "pick4"; 
          modl5_ = "modl5"; data5_ = "data5"; hess5_ = "hess5"; hesp5_ = "hesp5"; mmov5_ = "mmov5"; rmov5_ = "rmov5"; norm5_ ="norm5" ; wght5_ = "wg5"; mask5_ = "mask5"; epsi5_="epsi5"; lmbd5_="lmbd5"; pick5_ = "pick5"; 
          modl6_ = "modl6"; data6_ = "data6"; hess6_ = "hess6"; hesp6_ = "hesp6"; mmov6_ = "mmov6"; rmov6_ = "rmov6"; norm6_ ="norm6" ; wght6_ = "wg6"; mask6_ = "mask6"; epsi6_="epsi6"; lmbd6_="lmbd6"; pick6_ = "pick6"; 
          
          epsA_="epsA"; 
          epsB_="epsB"; 
          epsC_="epsC"; 
          epsD_="epsD"; 
          
	  F=.false.
	  T=.true.
          call from_param("data_lmb",data_lmb ,  F     );        
          call from_param("data_eps",data_eps ,  F     );        
          call from_param("method"  ,method   ,  1     ); 
          call from_param("adj"     ,adj      ,  T     );        
          call from_param("inv"     ,inv      ,  F     );
          call from_param("lump"    ,lump     ,  F     );       
          call from_param("diag"    ,diag     ,  F     ); 
          call from_param("full"    ,full     ,  F     );      
          call from_param("diag"    ,psf      ,  F     );  
          call from_param("dot"     ,dot      ,  F     );         
          call from_param("verb"    ,verb     ,  F     );         
          call from_param("joint"   ,joint    ,  T     ); 
          call from_param("weight"  ,weight   ,  F     );     
          call from_param("msk"     ,msk      ,  F     );         
          call from_param("precon"  ,precon   ,  F     ); 
          call from_param("noreg"   ,noreg    ,  F     ); 
          call from_param("timing1" ,timing1  ,  F     ); 
          call from_param("timing2" ,timing2  ,  F     ); 
          call from_param("niter"   ,niter    , 10     );
          call from_param("edge"    ,edge     , 0.3    ); 
          call from_param("    zmin",zmin     , -50.   ); 
          call from_param("    zmax",zmax     , 50.    ); 
          call from_param("    xmin",xmin     , 0.     ); 
          call from_param("    xmax",xmax     , xmin   ); 
          call from_param("rsv_zmin",rsv_zmin , 50.    ); 
          call from_param("rsv_zmax",rsv_zmax , zmax   ); 
          call from_param("rsv_xmin",rsv_xmin , -50.   ); 
          call from_param("rsv_xmax",rsv_xmax ,  50.   ); 
          call from_param("rtop"    ,rtop     , 1000   ); 
          call from_param("mode"    ,mode     , 1      );
          call from_param("nsurv"   ,nsurv    , 2      );
          call from_param("jmov", jmov, max(4,int(niter/50.)))
          call from_param("small"   ,small    ,  T     );
          call from_param("precond" ,precond  ,  F     );
          call from_param("dz_fact" ,dz_fact  ,  1.    );
          call from_param("ldz_fact",ldz_fact ,  F     );
          call from_param("lpick"   ,lpick    ,  T     );
          call from_param("reg_4d"  ,reg_4d   ,  1     );
          call from_param("reg_base",reg_base ,  1     );
          call from_param("pclip1"  ,pclip1   ,  0.1   );
          call from_param("pclip2"  ,pclip2   ,  0.2   );
          call from_param("flat"    ,flat     ,  F     );
          call from_param("halfhess",halfhess ,  F     );

          if((.not. precond ) .and. mode==4 )then; write(0,*)'You chose not to precond...and so you cant use mode=4 '; write(0,*)'changing to mode=1'; mode=1;endif
          if((.not. precond ) .and. mode==10)then; write(0,*)'You chose not to precond...and so you cant use mode=10'; write(0,*)'changing to mode=9'; mode=9;endif
          
          call from_param("nodes"   ,nodes    , 1      );

          nnode = omp_get_num_procs(); thread=omp_get_thread_num();  nodes=min(nnode-1,nodes); call omp_set_num_threads(nodes); write(*,*) 'using', nodes, 'of' , nnode
!
          call from_param("eps1",eps1,0.6);  call from_param("eps2",eps2,0.8);  call from_param("eps3",eps3,0.6);  call from_param("eps4",eps4,0.6);  call from_param("eps5",eps5,0.6);  call from_param("eps6",eps6,0.8); 
          call from_param("lmb1",lmb1,0.0);  call from_param("lmb2",lmb2,0.0);  call from_param("lmb3",lmb3,0.4);  call from_param("lmb4",lmb4,0.4);  call from_param("lmb5",lmb5,0.4);  call from_param("lmb6",lmb6,0.4);
          call from_param("epi1",epi1,0.6);  call from_param("epi2",epi2,0.8);  call from_param("epi3",epi3,0.6);  call from_param("epi4",epi4,0.6);  call from_param("epi5",epi5,0.6);  call from_param("epi6",epi6,0.8); 
          call from_param("lmd1",lmd1,0.0);  call from_param("lmd2",lmd2,0.0);  call from_param("lmd3",lmd3,0.4);  call from_param("lmd4",lmd4,0.4);  call from_param("lmd5",lmd5,0.4);  call from_param("lmd6",lmd6,0.4);
          call from_param("prc1",prc1,1.0);  call from_param("prc2",prc2,1.0);  call from_param("prc3",prc3,1.0);  call from_param("prc4",prc4,1.0);  call from_param("prc5",prc5,1.0);  call from_param("prc6",prc6,1.0);


          call from_param("epA1",epA1,0.6);  call from_param("epA2",epA2,0.6);  call from_param("epA3",epA3,0.6);  call from_param("epA4",epA4,0.6);  call from_param("epA5",epA5,0.6);  call from_param("epA6",epA6,0.6); 
          call from_param("epB1",epB1,0.6);  call from_param("epB2",epB2,0.6);  call from_param("epB3",epB3,0.6);  call from_param("epB4",epB4,0.6);  call from_param("epB5",epB5,0.6);  call from_param("epB6",epB6,0.6); 
          call from_param("epC1",epC1,0.6);  call from_param("epC2",epC2,0.6);  call from_param("epC3",epC3,0.6);  call from_param("epC4",epC4,0.6);  call from_param("epC5",epC5,0.6);  call from_param("epC6",epC6,0.6); 
          call from_param("epD1",epD1,0.6);  call from_param("epD2",epD2,0.6);  call from_param("epD3",epD3,0.6);  call from_param("epD4",epD4,0.6);  call from_param("epD5",epD5,0.6);  call from_param("epD6",epD6,0.6); 

          write(0,'(A48  )')'*****************************************************'
          write(0,'(A48  )')'eps1    eps2    eps3    eps4    eps5    eps6  '
          write(0,'(6F8.4)') eps1,   eps2,   eps3,   eps4,   eps5,   eps6  
          write(0,'(A48  )')'lmb1    lmb2    lmb3    lmb4    lmb5    lmb6  '
          write(0,'(6F8.4)') lmb1,   lmb2,   lmb3,   lmb4,   lmb5,   lmb6  
          write(0,'(A48  )')'*****************************************************'
          write(0,'(A48  )')'eps1    epA1    epB1    epC1    epD1    '
          write(0,'(6F8.4)') eps1,   epA1,   epB1,   epC1,   epD1  
          write(0,'(A48  )')'*****************************************************'

!!!!!!Hybrid norm
  !Type of norms to use
          call from_param("norm_d"      , norm_d       ,   'l2' ) !1:l2, 2:hb
          call from_param("norm_m"      , norm_m       ,   'hybrid' ) !1:l2, 2:hb 
          call from_param("norm_m1"     , norm_m1      ,   'hybrid' ) !1:l2, 2:hb
          call from_param("norm_m2"     , norm_m2      ,   'hybrid' ) !1:l2, 2:hb
          call from_param("norm_m3"     , norm_m3      ,   'hybrid' ) !1:l2, 2:hb
          call from_param("norm_m4"     , norm_m4      ,   'hybrid' ) !1:l2, 2:hb
  !quantiles
          call from_param("quant_d"     , quant_d      ,  0.5   ) !0-1
          call from_param("quant_m"     , quant_m      ,  0.5   ) !0-1
          call from_param("quant_m1"    , quant_m1     ,  0.5   ) !0-1
          call from_param("quant_m2"    , quant_m2     ,  0.5   ) !0-1
          call from_param("quant_m3"    , quant_m3     ,  0.5   ) !0-1
          call from_param("quant_m4"    , quant_m4     ,  0.5   ) !0-1
  !quantile period
          call from_param("quant_period", quant_period ,  1     ) !1-10
  !plane search iterations
          call from_param("psiter"      , psiter       ,  1     ) !1-10
  !plane search iterations
          call from_param("max_overshot", max_overshot ,  10    ) !1-10

          rtol=1.0e-10_dp
          tol=10e-10
          memory=0.
          iter=0.
  !impedance
          call from_param("rho", rho,  0.96   ) !0-1
          call from_param("limp", limp,  F    ) !T/F

  !pow fow weights 
          call from_param("gpow", gpow,  1.   ) !0-10
          call from_param("wpow", wpow,  1.   ) !0-10
          call from_param("hpow", hpow,  1.   ) !0-10

   !report
          call from_param("report",report_, "report");
          open(unit=10, file=report_, status='unknown');
   !report error
          call from_param("err",err_, "err");
          open(unit=11, file=err_, status='unknown');

          call from_param("polarity", polarity,  1 ) !+1 or -1
        
  end subroutine

end module