module joint_encode_adjnull
 use joint_encode_params

 implicit none
 contains
!#####################################################  
  subroutine joint_adjnull3(adj,add,modl,data)
  logical                    ::  adj, add
  real, dimension(:), target :: modl, data
        call adjnull(adj,add,modl,data)
                if (nsurv >14) then; m15=>modl(14*nmod+1:15*nmod); d15=>data(14*ndat+1:15*ndat); endif 
                if (nsurv >13) then; m14=>modl(13*nmod+1:14*nmod); d14=>data(13*ndat+1:14*ndat); endif 
                if (nsurv >12) then; m13=>modl(12*nmod+1:13*nmod); d13=>data(12*ndat+1:13*ndat); endif 
                if (nsurv >11) then; m12=>modl(11*nmod+1:12*nmod); d12=>data(11*ndat+1:12*ndat); endif 
                if (nsurv >10) then; m11=>modl(10*nmod+1:11*nmod); d11=>data(10*ndat+1:11*ndat); endif 
                if (nsurv > 9) then; m10=>modl( 9*nmod+1:10*nmod); d10=>data( 9*ndat+1:10*ndat); endif 
                if (nsurv > 8) then;  m9=>modl( 8*nmod+1: 9*nmod);  d9=>data( 8*ndat+1: 9*ndat); endif 
                if (nsurv > 7) then;  m8=>modl( 7*nmod+1: 8*nmod);  d8=>data( 7*ndat+1: 8*ndat); endif 
                if (nsurv > 6) then;  m7=>modl( 6*nmod+1: 7*nmod);  d7=>data( 6*ndat+1: 7*ndat); endif 
                if (nsurv > 5) then;  m6=>modl( 5*nmod+1: 6*nmod);  d6=>data( 5*ndat+1: 6*ndat); endif 
                if (nsurv > 4) then;  m5=>modl( 4*nmod+1: 5*nmod);  d5=>data( 4*ndat+1: 5*ndat); endif
                if (nsurv > 3) then;  m4=>modl( 3*nmod+1: 4*nmod);  d4=>data( 3*ndat+1: 4*ndat); endif
                if (nsurv > 2) then;  m3=>modl( 2*nmod+1: 3*nmod);  d3=>data( 2*ndat+1: 3*ndat); endif
                if (nsurv > 1) then;  m2=>modl( 1*nmod+1: 2*nmod);  d2=>data( 1*ndat+1: 2*ndat); endif
                if (nsurv > 0) then;  m1=>modl( 0*nmod+1: 1*nmod);  d1=>data( 0*ndat+1: 1*ndat); endif
 end subroutine
!#####################################################  
  subroutine joint_adjnull2(adj,add,modl,data)
  logical                   ::  adj, add
  real, dimension(:),target :: modl, data
        call adjnull(adj,add,modl,data)
        d1=>data(0*nmod+1:1*nmod); d2=>data(1*nmod+1:2*nmod); d3=>data(2*nmod+1:3*nmod);  d4=>data(3*nmod+1:4*nmod);  d5=>data(4*nmod+1:5*nmod);  d6=>data(5*nmod+1:6*nmod); d7=>data(6*nmod+1:7*nmod); d8=>data(7*nmod+1:8*nmod); d9=>data(8*nmod+1:9*nmod); d10=>data(9*nmod+1:10*nmod); d11=>data(10*nmod+1:11*nmod); d12=>data(11*nmod+1:12*nmod); d13=>data(12*nmod+1:13*nmod); d14=>data(13*nmod+1:14*nmod); d15=>data(14*nmod+1:15*nmod);
        m1=>modl(0*nmod+1:1*nmod); m2=>modl(1*nmod+1:2*nmod); m3=>modl(2*nmod+1:3*nmod);  m4=>modl(3*nmod+1:4*nmod);  m5=>modl(4*nmod+1:5*nmod);  m6=>modl(5*nmod+1:6*nmod); m7=>modl(6*nmod+1:7*nmod); m8=>modl(7*nmod+1:8*nmod); m9=>modl(8*nmod+1:9*nmod); m10=>modl(9*nmod+1:10*nmod); m11=>modl(10*nmod+1:11*nmod); m12=>modl(11*nmod+1:12*nmod); m13=>modl(12*nmod+1:13*nmod); m14=>modl(13*nmod+1:14*nmod); m15=>modl(14*nmod+1:15*nmod);
 end subroutine
!#####################################################  
  subroutine joint_adjnull_oper(adj,add,modl,data)
  logical                   ::  adj, add
  real, dimension(:),target :: modl, data
        call adjnull(adj,add,modl,data)
        d1=>data(0*ndat+1:1*ndat); d2=>data(1*ndat+1:2*ndat); d3=>data(2*ndat+1:3*ndat);  d4=>data(3*ndat+1:4*ndat);  d5=>data(4*ndat+1:5*ndat);  d6=>data(5*ndat+1:6*ndat); d7=>data(6*ndat+1:7*ndat); d8=>data(7*ndat+1:8*ndat); d9=>data(8*ndat+1:9*ndat); d10=>data(9*ndat+1:10*ndat); d11=>data(10*ndat+1:11*ndat); d12=>data(11*ndat+1:12*ndat); d13=>data(12*ndat+1:13*ndat); d14=>data(13*ndat+1:14*ndat); d15=>data(14*ndat+1:15*ndat);
        m1=>modl(0*nmod+1:1*nmod); m2=>modl(1*nmod+1:2*nmod); m3=>modl(2*nmod+1:3*nmod);  m4=>modl(3*nmod+1:4*nmod);  m5=>modl(4*nmod+1:5*nmod);  m6=>modl(5*nmod+1:6*nmod); m7=>modl(6*nmod+1:7*nmod); m8=>modl(7*nmod+1:8*nmod); m9=>modl(8*nmod+1:9*nmod); m10=>modl(9*nmod+1:10*nmod); m11=>modl(10*nmod+1:11*nmod); m12=>modl(11*nmod+1:12*nmod); m13=>modl(12*nmod+1:13*nmod); m14=>modl(13*nmod+1:14*nmod); m15=>modl(14*nmod+1:15*nmod);
 end subroutine
!#####################################################  
  subroutine joint_adjnull_vel(adj,add,vel)
  logical                   ::  adj, add
  real   , dimension(:),target :: vel
         v1=>vel(0*nmod     +1:1*nmod     );  v2=>vel(1*nmod     +1:2*nmod     );  v3=>vel(2*nmod     +1:3*nmod     );   v4=>vel(3*nmod     +1:4*nmod      );   v5=>vel(4*nmod     +1:5*nmod     );   v6=>vel(5*nmod     +1:6*nmod     );  
         v7=>vel(6*nmod     +1:7*nmod     );  v8=>vel(7*nmod     +1:8*nmod     );  v9=>vel(8*nmod     +1:9*nmod     );  v10=>vel(9*nmod     +1:10*nmod     );  v11=>vel(10*nmod    +1:11*nmod    );  v12=>vel(11*nmod    +1:12*nmod    );  
        v13=>vel(12*nmod    +1:13*nmod    ); v14=>vel(13*nmod    +1:14*nmod    ); v15=>vel(14*nmod    +1:15*nmod    );
 end subroutine
!#####################################################  
  subroutine joint_adjnull_foper(adj,add,modl,data)
  logical                   ::  adj, add
  real   , dimension(:),target :: modl
  complex, dimension(:),target :: data
        fd1=>data(0*ndat_real+1:1*ndat_real); fd2=>data(1*ndat_real+1:2*ndat_real); fd3=>data(2*ndat_real+1:3*ndat_real);  fd4=>data(3*ndat_real+1:4*ndat_real);  fd5=>data(4*ndat_real+1:5*ndat_real);  fd6=>data(5*ndat_real+1:6*ndat_real); fd7=>data(6*ndat_real+1:7*ndat_real); fd8=>data(7*ndat_real+1:8*ndat_real); fd9=>data(8*ndat_real+1:9*ndat_real); fd10=>data(9*ndat_real+1:10*ndat_real); fd11=>data(10*ndat_real+1:11*ndat_real); fd12=>data(11*ndat_real+1:12*ndat_real); fd13=>data(12*ndat_real+1:13*ndat_real); fd14=>data(13*ndat_real+1:14*ndat_real); fd15=>data(14*ndat_real+1:15*ndat_real);
         m1=>modl(0*nmod     +1:1*nmod     );  m2=>modl(1*nmod     +1:2*nmod     );  m3=>modl(2*nmod     +1:3*nmod     );   m4=>modl(3*nmod     +1:4*nmod     );   m5=>modl(4*nmod     +1:5*nmod     );   m6=>modl(5*nmod     +1:6*nmod     );  m7=>modl(6*nmod     +1:7*nmod     );  m8=>modl(7*nmod     +1:8*nmod     );  m9=>modl(8*nmod     +1:9*nmod     );  m10=>modl(9*nmod     +1:10*nmod     );  m11=>modl(10*nmod     +1:11*nmod     );  m12=>modl(11*nmod     +1:12*nmod     );  m13=>modl(12*nmod     +1:13*nmod     );  m14=>modl(13*nmod     +1:14*nmod     );  m15=>modl(14*nmod     +1:15*nmod     );
 end subroutine
!#####################################################  
  subroutine joint_adjnull_real_data(data)
  real, dimension(:),target :: data
            d1 =>data(0 *ndat_real+1: 1*ndat_real); d2 =>data(1 *ndat_real+1:2 *ndat_real); d3 =>data(2 *ndat_real+1:3 *ndat_real);
            d4 =>data(3 *ndat_real+1: 4*ndat_real); d5 =>data(4 *ndat_real+1:5 *ndat_real); d6 =>data(5 *ndat_real+1:6 *ndat_real);
            d7 =>data(6 *ndat_real+1: 7*ndat_real); d8 =>data(7 *ndat_real+1:8 *ndat_real); d9 =>data(8 *ndat_real+1:9 *ndat_real);
            d10=>data(9 *ndat_real+1:10*ndat_real); d11=>data(10*ndat_real+1:12*ndat_real); d12=>data(11*ndat_real+1:12*ndat_real);
            d13=>data(12*ndat_real+1:13*ndat_real); d14=>data(13*ndat_real+1:14*ndat_real); d15=>data(14*ndat_real+1:15*ndat_real);
 end subroutine
!#####################################################  
  subroutine joint_adjnull_oper3(adj,add,modl,data)
  logical                       ::  adj, add
  real,    dimension(:,:,:)     :: modl 
  complex, dimension(:,:,:,:)   :: data
        if (add)then
                if (adj )then
                        modl=modl
                else
                        data=data
                endif            
        else
                if (adj )then
                        modl=0.
                else
                        data=0.
                endif            
        endif                                
 end subroutine
   !#####################################################  
  subroutine joint_adjnull_link(adj,fwd,modl,data)
        logical            :: adj,  fwd
        real, dimension(:) :: modl, data

   if ((method==1.and.fwd).or.(method==2.and.(.not. fwd)))then
        if (nsurv >14) m15=m15+m14;
        if (nsurv >13) m14=m14+m13;
        if (nsurv >13) m13=m13+m12;
        if (nsurv >11) m12=m12+m11;
        if (nsurv >10) m11=m11+m10;
        if (nsurv > 9) m10=m10+m9 ;
        if (nsurv > 8) m9 =m9 +m8 ;
        if (nsurv > 7) m8 =m8 +m7 ;
        if (nsurv > 6) m7 =m7 +m6 ;
        if (nsurv > 5) m6 =m6 +m5 ;
        if (nsurv > 4) m5 =m5 +m4 ;
        if (nsurv > 3) m4 =m4 +m3 ;
        if (nsurv > 2) m3 =m3 +m2 ;
        if (nsurv > 1) m2 =m2 +m1 ;
        if (nsurv > 0) m1 =m1
   else
        if (nsurv >14) m15=m15-m14;
        if (nsurv >13) m14=m14-m13;
        if (nsurv >13) m13=m13-m12;
        if (nsurv >11) m12=m12-m11;
        if (nsurv >10) m11=m11-m10;
        if (nsurv > 9) m10=m10-m9 ;
        if (nsurv > 8) m9 =m9 -m8 ;
        if (nsurv > 7) m8 =m8 -m7 ;
        if (nsurv > 6) m7 =m7 -m6 ;
        if (nsurv > 5) m6 =m6 -m5 ;
        if (nsurv > 4) m5 =m5 -m4 ;
        if (nsurv > 3) m4 =m4 -m3 ;
        if (nsurv > 2) m3 =m3 -m2 ;
        if (nsurv > 1) m2 =m2 -m1 ;
        if (nsurv > 0) m1 =m1
  endif        
end subroutine

!#####################################################  
  subroutine joint_adjnull(adj,add,modl,data)
  logical                       ::  adj, add
  real, dimension(:),target     :: modl, data

        call adjnull(adj,add,modl,data)
                if (nsurv >14) then; m15=>modl(14*nmod+1:15*nmod); d15=>data(14*ndat+1:15*ndat); endif 
                if (nsurv >13) then; m14=>modl(13*nmod+1:14*nmod); d14=>data(13*ndat+1:14*ndat); endif 
                if (nsurv >12) then; m13=>modl(12*nmod+1:13*nmod); d13=>data(12*ndat+1:13*ndat); endif 
                if (nsurv >11) then; m12=>modl(11*nmod+1:12*nmod); d12=>data(11*ndat+1:12*ndat); endif 
                if (nsurv >10) then; m11=>modl(10*nmod+1:11*nmod); d11=>data(10*ndat+1:11*ndat); endif 
                if (nsurv > 9) then; m10=>modl( 9*nmod+1:10*nmod); d10=>data( 9*ndat+1:10*ndat); endif 
                if (nsurv > 8) then;  m9=>modl( 8*nmod+1: 9*nmod);  d9=>data( 8*ndat+1: 9*ndat); endif 
                if (nsurv > 7) then;  m8=>modl( 7*nmod+1: 8*nmod);  d8=>data( 7*ndat+1: 8*ndat); endif 
                if (nsurv > 6) then;  m7=>modl( 6*nmod+1: 7*nmod);  d7=>data( 6*ndat+1: 7*ndat); endif 
                if (nsurv > 5) then;  m6=>modl( 5*nmod+1: 6*nmod);  d6=>data( 5*ndat+1: 6*ndat); endif 
                if (nsurv > 4) then;  m5=>modl( 4*nmod+1: 5*nmod);  d5=>data( 4*ndat+1: 5*ndat); endif
                if (nsurv > 3) then;  m4=>modl( 3*nmod+1: 4*nmod);  d4=>data( 3*ndat+1: 4*ndat); endif
                if (nsurv > 2) then;  m3=>modl( 2*nmod+1: 3*nmod);  d3=>data( 2*ndat+1: 3*ndat); endif
                if (nsurv > 1) then;  m2=>modl( 1*nmod+1: 2*nmod);  d2=>data( 1*ndat+1: 2*ndat); endif   
                if (nsurv > 0) then;  m1=>modl( 0*nmod+1: 1*nmod);  d1=>data( 0*ndat+1: 1*ndat); endif
 end subroutine
!#####################################################  
  subroutine joint_adjnull_inv()
        dips1=>dips0(0*nmod+1:1*nmod);   dips2=>dips0(1*nmod+1:2*nmod);  dips3=>dips0(2*nmod+1:3*nmod);  dips4=>dips0(3*nmod+1:4*nmod);  dips5=>dips0(4*nmod+1:5*nmod);  dips6=>dips0(5*nmod+1:6*nmod); dips7=>dips0(6*nmod+1:7*nmod); dips8=>dips0(7*nmod+1:8*nmod); dips9=>dips0(8*nmod+1:9*nmod); dips10=>dips0(9*nmod+1:10*nmod); dips11=>dips0(10*nmod+1:11*nmod); dips12=>dips0(11*nmod+1:12*nmod); dips13=>dips0(12*nmod+1:13*nmod); dips14=>dips0(13*nmod+1:14*nmod); dips15=>dips0(14*nmod+1:15*nmod);
        epsi1=>epsi0(0*nmod+1:1*nmod);   epsi2=>epsi0(1*nmod+1:2*nmod);  epsi3=>epsi0(2*nmod+1:3*nmod);  epsi4=>epsi0(3*nmod+1:4*nmod);  epsi5=>epsi0(4*nmod+1:5*nmod);  epsi6=>epsi0(5*nmod+1:6*nmod); epsi7=>epsi0(6*nmod+1:7*nmod); epsi8=>epsi0(7*nmod+1:8*nmod); epsi9=>epsi0(8*nmod+1:9*nmod); epsi10=>epsi0(9*nmod+1:10*nmod); epsi11=>epsi0(10*nmod+1:11*nmod); epsi12=>epsi0(11*nmod+1:12*nmod); epsi13=>epsi0(12*nmod+1:13*nmod); epsi14=>epsi0(13*nmod+1:14*nmod); epsi15=>epsi0(14*nmod+1:15*nmod);
        lmbd1=>lmbd0(0*nmod+1:1*nmod);   lmbd2=>lmbd0(1*nmod+1:2*nmod);  lmbd3=>lmbd0(2*nmod+1:3*nmod);  lmbd4=>lmbd0(3*nmod+1:4*nmod);  lmbd5=>lmbd0(4*nmod+1:5*nmod);  lmbd6=>lmbd0(5*nmod+1:6*nmod); lmbd7=>lmbd0(6*nmod+1:7*nmod); lmbd8=>lmbd0(7*nmod+1:8*nmod); lmbd9=>lmbd0(8*nmod+1:9*nmod); lmbd10=>lmbd0(9*nmod+1:10*nmod); lmbd11=>lmbd0(10*nmod+1:11*nmod); lmbd12=>lmbd0(11*nmod+1:12*nmod); lmbd13=>lmbd0(12*nmod+1:13*nmod); lmbd14=>lmbd0(13*nmod+1:14*nmod); lmbd15=>lmbd0(14*nmod+1:15*nmod);
           f1=>   f0(0*nmod+1:1*nmod);   f2   =>   f0(1*nmod+1:2*nmod);     f3=>   f0(2*nmod+1:3*nmod);     f4=>   f0(3*nmod+1:4*nmod);     f5=>   f0(4*nmod+1:5*nmod);     f6=>   f0(5*nmod+1:6*nmod);    f7=>   f0(6*nmod+1:7*nmod);    f8=>   f0(7*nmod+1:8*nmod);    f9=>   f0(8*nmod+1:9*nmod);    f10=>   f0(9*nmod+1:10*nmod);    f11=>   f0(10*nmod+1:11*nmod);    f12=>   f0(11*nmod+1:12*nmod);    f13=>   f0(12*nmod+1:13*nmod);    f14=>   f0(13*nmod+1:14*nmod);    f15=>   f0(14*nmod+1:15*nmod);
           s1=>   s0(0*nmod+1:1*nmod);   s2   =>   s0(1*nmod+1:2*nmod);     s3=>   s0(2*nmod+1:3*nmod);     s4=>   s0(3*nmod+1:4*nmod);     s5=>   s0(4*nmod+1:5*nmod);     s6=>   s0(5*nmod+1:6*nmod);    s7=>   s0(6*nmod+1:7*nmod);    s8=>   s0(7*nmod+1:8*nmod);    s9=>   s0(8*nmod+1:9*nmod);    s10=>   s0(9*nmod+1:10*nmod);    s11=>   s0(10*nmod+1:11*nmod);    s12=>   s0(11*nmod+1:12*nmod);    s13=>   s0(12*nmod+1:13*nmod);    s14=>   s0(13*nmod+1:14*nmod);    s15=>   s0(14*nmod+1:15*nmod);
  end subroutine

   

end module
