module joint_encode_init
 use joint_encode_data_param
 use joint_encode_adjnull
 use joint_encode_data_io
 use quantile_mod
 use quantile_mod1
 implicit none

 contains
  !#########################################
 subroutine joint_encode_aux_init()
        write(0,*)'Initializing aux. inputs for [', nsurv, '] surveys'
        if (nsurv > 0)call encode_aux_init(modl1_, data1_, vel1_ ,hesp1_, hess1_, epsi1_, lmbd1_, mask1_, wght1_, pick1_, rmov1_, mmov1_, norm1_, dips1_, f1_, s1_, ts1_, sd1_, cc1_,rr1_ , wfld1_, souz1_, sv1_ , smodl1_ ,maps1_ ,1 ); 
        if (nsurv > 1)call encode_aux_init(modl2_, data2_, vel2_ ,hesp2_, hess2_, epsi2_, lmbd2_, mask2_, wght2_, pick2_, rmov2_, mmov2_, norm2_, dips2_, f2_, s2_, ts2_, sd2_, cc2_,rr2_ , wfld2_, souz2_, sv2_ , smodl2_ ,maps2_ ,2 ); 
        if (nsurv > 2)call encode_aux_init(modl3_, data3_, vel3_ ,hesp3_, hess3_, epsi3_, lmbd3_, mask3_, wght3_, pick3_, rmov3_, mmov3_, norm3_, dips3_, f3_, s3_, ts3_, sd3_, cc3_,rr3_ , wfld3_, souz3_, sv3_ , smodl3_ ,maps3_ ,3 ); 
        if (nsurv > 3)call encode_aux_init(modl4_, data4_, vel4_ ,hesp4_, hess4_, epsi4_, lmbd4_, mask4_, wght4_, pick4_, rmov4_, mmov4_, norm4_, dips4_, f4_, s4_, ts4_, sd4_, cc4_,rr4_ , wfld4_, souz4_, sv4_ , smodl4_ ,maps4_ ,4 ); 
        if (nsurv > 4)call encode_aux_init(modl5_, data5_, vel5_ ,hesp5_, hess5_, epsi5_, lmbd5_, mask5_, wght5_, pick5_, rmov5_, mmov5_, norm5_, dips5_, f5_, s5_, ts5_, sd5_, cc5_,rr5_ , wfld5_, souz5_, sv5_ , smodl5_ ,maps5_ ,5 ); 
        if (nsurv > 5)call encode_aux_init(modl6_, data6_, vel6_ ,hesp6_, hess6_, epsi6_, lmbd6_, mask6_, wght6_, pick6_, rmov6_, mmov6_, norm6_, dips6_, f6_, s6_, ts6_, sd6_, cc6_,rr6_ , wfld6_, souz6_, sv6_ , smodl6_ ,maps6_ ,6 ); 
        if (nsurv > 6)call encode_aux_init(modl7_, data7_, vel7_ ,hesp7_, hess7_, epsi7_, lmbd7_, mask7_, wght7_, pick7_, rmov7_, mmov7_, norm7_, dips7_, f7_, s7_, ts7_, sd7_, cc7_,rr7_ , wfld7_, souz7_, sv7_ , smodl7_ ,maps7_ ,7 ); 
        if (nsurv > 7)call encode_aux_init(modl8_, data8_, vel8_ ,hesp8_, hess8_, epsi8_, lmbd8_, mask8_, wght8_, pick8_, rmov8_, mmov8_, norm8_, dips8_, f8_, s8_, ts8_, sd8_, cc8_,rr8_ , wfld8_, souz8_, sv8_ , smodl8_ ,maps8_ ,8 ); 
        if (nsurv > 8)call encode_aux_init(modl9_, data9_, vel9_ ,hesp9_, hess9_, epsi9_, lmbd9_, mask9_, wght9_, pick9_, rmov9_, mmov9_, norm9_, dips9_, f9_, s9_, ts9_, sd9_, cc9_,rr9_ , wfld9_, souz9_, sv9_ , smodl9_ ,maps9_ ,9 );
        if (nsurv > 9)call encode_aux_init(modl10_,data10_,vel10_,hesp10_,hess10_,epsi10_,lmbd10_,mask10_,wght10_,pick10_,rmov10_,mmov10_,norm10_,dips10_,f10_,s10_,ts10_,sd10_,cc10_,rr10_,wfld10_,souz10_,sv10_, smodl10_,maps10_,10);
        if (nsurv >10)call encode_aux_init(modl11_,data11_,vel11_,hesp11_,hess11_,epsi11_,lmbd11_,mask11_,wght11_,pick11_,rmov11_,mmov11_,norm11_,dips11_,f11_,s11_,ts11_,sd11_,cc11_,rr11_,wfld11_,souz11_,sv11_, smodl11_,maps11_,11); 
        if (nsurv >11)call encode_aux_init(modl12_,data12_,vel12_,hesp12_,hess12_,epsi12_,lmbd12_,mask12_,wght12_,pick12_,rmov12_,mmov12_,norm12_,dips12_,f12_,s12_,ts12_,sd12_,cc12_,rr12_,wfld12_,souz12_,sv12_, smodl12_,maps12_,12); 
        if (nsurv >12)call encode_aux_init(modl13_,data13_,vel13_,hesp13_,hess13_,epsi13_,lmbd13_,mask13_,wght13_,pick13_,rmov13_,mmov13_,norm13_,dips13_,f13_,s13_,ts13_,sd13_,cc13_,rr13_,wfld13_,souz13_,sv13_, smodl13_,maps13_,13); 
        if (nsurv >13)call encode_aux_init(modl14_,data14_,vel14_,hesp14_,hess14_,epsi14_,lmbd14_,mask14_,wght14_,pick14_,rmov14_,mmov14_,norm14_,dips14_,f14_,s14_,ts14_,sd14_,cc14_,rr14_,wfld14_,souz14_,sv14_, smodl14_,maps14_,14); 
        if (nsurv >14)call encode_aux_init(modl15_,data15_,vel15_,hesp15_,hess15_,epsi15_,lmbd15_,mask15_,wght15_,pick15_,rmov15_,mmov15_,norm15_,dips15_,f15_,s15_,ts15_,sd15_,cc15_,rr15_,wfld15_,souz15_,sv15_, smodl15_,maps15_,15);
        if (nsurv >15)call seperr('Why do you have more than six surveys??? your field shld be dry by now.....Talk to ur manager!!!!!!')
        write(0,*)'Done initializing ALL surveys'
  end subroutine
!#########################################
  subroutine  encode_aux_init(modl_n, data_n, vel_n, hesp_n, hess_n, epsi_n, lmbd_n, mask_n, wght_n, pick_n, rmov_n, mmov_n, norm_n, dips_n, f_n, s_n, ts_n, sd_n, cc_n, rr_n, wfld_n, souz_n, sv_n, sm_n, mp_n, i)
  character(len=256)     :: modl_n, data_n, vel_n, hesp_n, hess_n, epsi_n, lmbd_n, mask_n, wght_n, pick_n, rmov_n, mmov_n, norm_n, dips_n, f_n, s_n, ts_n, sd_n, cc_n, rr_n, wfld_n, souz_n, sv_n, sm_n, mp_n
  integer                :: i
  type(axis)             :: xyz 
        call auxinout(modl_n);  write(0,'(A18)',advance='no')'Initialized Modl...' 
        call auxinout(data_n);  write(0,'(A10)',advance='no')'Data...'
        call auxin (hess_n);    write(0,'(A10)',advance='no')'Hess...'
        if (exist_file(vel_n )) then; write(0,'(A10)',advance='no')'Vel....'  ; call auxinout (vel_n ); endif
        if (exist_file(epsi_n)) then; write(0,'(A10)',advance='no')'Epsi...'  ; call auxinout (epsi_n); endif
        if (exist_file(dips_n)) then; write(0,'(A10)',advance='no')'Dips...'  ; call auxinout (dips_n); endif
        if (exist_file(f_n   )) then; write(0,'(A10)',advance='no')'Faults...'; call auxin    (f_n   ); endif
        if (exist_file(s_n   )) then; write(0,'(A10)',advance='no')'Salt...'  ; call auxin    (s_n   ); endif
        if (exist_file(ts_n  )) then; write(0,'(A10)',advance='no')'Tshift...'; call auxinout (ts_n  ); endif
        if (exist_file(sd_n  )) then; write(0,'(A10)',advance='no')'Tst-diff.'; call auxinout (sd_n  ); endif
        if (exist_file(cc_n  )) then; write(0,'(A10)',advance='no')'Ccorr...' ; call auxinout (cc_n  ); endif 
        if (exist_file(rr_n  )) then; write(0,'(A10)',advance='no')'Repeat...'; call auxinout (rr_n  ); endif 
        if (exist_file(souz_n)) then; write(0,'(A10)',advance='no')'Souz.....'; call auxinout (souz_n); endif 
        if (exist_file(mp_n)) then; write(0,'(A10)',advance='no')'Map......'; call auxinout (mp_n); endif 
        if (exist_file(sv_n)) then; write(0,'(A10)',advance='no')'SVel.....'; call auxinout (sv_n); endif 
        if (exist_file(sm_n)) then; write(0,'(A10)',advance='no')'SModl....'; call auxinout (sm_n); endif 
        if (exist_file(wfld_n).and.wfld_d_out) then; write(0,'(A15)',advance='no')'Wfld...'; call auxinout (wfld_n); endif 

        if (inv)then
                if(i==1)call auxout(mmov_);
                if(i==1)call auxout(rmov_);
                call auxout(mmov_n); write(0,'(A10)',advance='no')'Mmov...'
                call auxout(rmov_n); write(0,'(A10)',advance='no')'Rmov...'
                call auxout(norm_n); write(0,'(A10)',advance='no')'Norm...'
                if(all)then        
                        if ( exist_file(mask_n  )) then; write(0,'(A10)',advance='no')'Mask..:'; call auxin (mask_n  ); write(0,'(A10)',advance='no')'Done Mask...'; endif
                        if (weight .and. exist_file(wght_n  )) then; write(0,'(A10)',advance='no')'Wght..:'; call auxin (wght_n  ); write(0,'(A10)',advance='no')'Done Wght...'; endif 
                        if (lpick  .and. exist_file(pick_n  )) then; write(0,'(A10)',advance='no')'Pick..:'; call auxin (pick_n  ); write(0,'(A10)',advance='no')'Done Pick...'; endif
                        if (             exist_file(lmbd_n  )) then; write(0,'(A10)',advance='no')'Lmbs..:'; call auxin (lmbd_n  ); write(0,'(A10)',advance='no')'Done Lmbd...'; endif
                        if (precond.and. exist_file(hesp_n  )) then; write(0,'(A10)',advance='no')'Hesp..:'; call auxin (hesp_n  ); write(0,'(A10)',advance='no')'Done Hesp...'; endif
                endif
        endif
        write(0,'(A30,I2)',advance='yes')'Done initializing surv...', i

!time shift stuff for modeling
xyz%o=0; xyz%d=1; xyz%n=3

!if((.not.inv))then
        if(lsft)then
                if((.not.use_shft).and.exist_file(ts_n)) then;   
                        call houaxis2(ts_n, vgrid%ax, 1);call houaxis2(ts_n, vgrid%ay, 2); call houaxis2(ts_n,vgrid%az, 3); call houaxis2(ts_n,xyz,4);
                        ts0(1:nmod,:)=0; call ts_io("rite",  ts0(1:nmod,:), i, F); 
                endif
        endif
        if(lsd)then
                if(exist_file(sd_n)) then
                        call houaxis2(sd_n, vgrid%ax, 1);call houaxis2(ts_n, vgrid%ay, 2); call houaxis2(ts_n,vgrid%az, 3); call houaxis2(ts_n,xyz,4);
                        sd0(1:nmod,:)=0;  call sd_io("rite", ts0(1:nmod,:), i); 
                endif
        endif
        if(lcc )then
                        call houaxis2(cc_n, vgrid%ax, 1);call houaxis2(cc_n, vgrid%ay, 2); call houaxis2(cc_n,vgrid%az, 3); call houaxis2(cc_n,xyz,4);
                        cc0(1:nmod,:)=0; if(exist_file(cc_n))call cc_io("rite",  cc0(1:nmod,:), i, F);
        endif
        if(lsv )then
                        call houaxis2(sv_n, vgrid%ax, 1);call houaxis2(sv_n, vgrid%ay, 2); call houaxis2(sv_n,vgrid%az, 3);
                        ts0(1:nmod,1)=0; if(exist_file(sv_n))call sv_io("rite",  ts0(1:nmod,1), i);
        endif
       
        !endif
  end subroutine

!#####################################################
  subroutine joint_encode_inout_init()
        call joint_adjnull_foper(F,F,modl0,fdata0)!initialize pointers to the full joint datasets
        call joint_adjnull_vel(F,F,vel0)          !initialize pointers to the full joint velocities
        !call joint_adjnull_real_data(data0)!initialize pointers to the full joint datasets
        call joint_adjnull_inv()!initialize pointers to the full aux files
        if(all)then; mask0=0. ; wght0=0.; epsi0=1.; lmbd0=1. ; data0=0; endif
        if (nsurv > 0) call encode_inout_init(modl1_, data1_, vel1_,  hesp1_, mask1_, epsi1_, lmbd1_, wght1_, pick1_, mmov1_, rmov1_, norm1_, dips1_, f1_, s1_, ts1_, ts1_, cc1_, rr1_ ,wfld1_ , souz1_, sv1_ ,smodl1_ ,maps1_  ,1 ) !init aux files and read in the datasetsft
        if (nsurv > 1) call encode_inout_init(modl2_, data2_, vel2_,  hesp2_, mask2_, epsi2_, lmbd2_, wght2_, pick2_, mmov2_, rmov2_, norm2_, dips2_, f2_, s2_, ts2_, ts2_, cc2_, rr2_ ,wfld2_ , souz2_, sv2_ ,smodl2_ ,maps2_  ,2 )
        if (nsurv > 2) call encode_inout_init(modl3_, data3_, vel3_,  hesp3_, mask3_, epsi3_, lmbd3_, wght3_, pick3_, mmov3_, rmov3_, norm3_, dips3_, f3_, s3_, ts3_, ts3_, cc3_, rr3_ ,wfld3_ , souz3_, sv3_ ,smodl3_ ,maps3_  ,3 )
        if (nsurv > 3) call encode_inout_init(modl4_, data4_, vel4_,  hesp4_, mask4_, epsi4_, lmbd4_, wght4_, pick4_, mmov4_, rmov4_, norm4_, dips4_, f4_, s4_, ts4_, ts4_, cc4_, rr4_ ,wfld4_ , souz4_, sv4_ ,smodl4_ ,maps4_  ,4 )
        if (nsurv > 4) call encode_inout_init(modl5_, data5_, vel5_,  hesp5_, mask5_, epsi5_, lmbd5_, wght5_, pick5_, mmov5_, rmov5_, norm5_, dips5_, f5_, s5_, ts5_, ts5_, cc5_, rr5_ ,wfld5_ , souz5_, sv5_ ,smodl5_ ,maps5_  ,5 )
        if (nsurv > 5) call encode_inout_init(modl6_, data6_, vel6_,  hesp6_, mask6_, epsi6_, lmbd6_, wght6_, pick6_, mmov6_, rmov6_, norm6_, dips6_, f6_, s6_, ts6_, ts6_, cc6_, rr6_ ,wfld6_ , souz6_, sv6_ ,smodl6_ ,maps6_  ,6 )
        if (nsurv > 6) call encode_inout_init(modl7_, data7_, vel7_,  hesp7_, mask7_, epsi7_, lmbd7_, wght7_, pick7_, mmov7_, rmov7_, norm7_, dips7_, f7_, s7_, ts7_, ts7_, cc7_, rr7_ ,wfld7_ , souz7_, sv7_ ,smodl7_ ,maps7_  ,7 )
        if (nsurv > 7) call encode_inout_init(modl8_, data8_, vel8_,  hesp8_, mask8_, epsi8_, lmbd8_, wght8_, pick8_, mmov8_, rmov8_, norm8_, dips8_, f8_, s8_, ts8_, ts8_, cc8_, rr8_ ,wfld8_ , souz8_, sv8_ ,smodl8_ ,maps8_  ,8 )
        if (nsurv > 8) call encode_inout_init(modl9_, data9_, vel9_,  hesp9_, mask9_, epsi9_, lmbd9_, wght9_, pick9_, mmov9_, rmov9_, norm9_, dips9_, f9_, s9_, ts9_, ts9_, cc9_, rr9_ ,wfld9_ , souz9_, sv9_ ,smodl9_ ,maps9_  ,9 )
        if (nsurv > 9) call encode_inout_init(modl10_,data10_,vel10_, hesp10_,mask10_,epsi10_,lmbd10_,wght10_,pick10_,mmov10_,rmov10_,norm10_,dips10_,f10_,s10_,ts10_,ts10_,cc10_,rr10_,wfld10_, souz10_,sv10_,smodl10_,maps10_ ,10)
        if (nsurv >10) call encode_inout_init(modl11_,data11_,vel11_, hesp11_,mask11_,epsi11_,lmbd11_,wght11_,pick11_,mmov11_,rmov11_,norm11_,dips11_,f11_,s11_,ts11_,ts11_,cc11_,rr11_,wfld11_, souz11_,sv11_,smodl11_,maps11_ ,11)
        if (nsurv >11) call encode_inout_init(modl12_,data12_,vel12_, hesp12_,mask12_,epsi12_,lmbd12_,wght12_,pick12_,mmov12_,rmov12_,norm12_,dips12_,f12_,s12_,ts12_,ts12_,cc12_,rr12_,wfld12_, souz12_,sv12_,smodl12_,maps12_ ,12)
        if (nsurv >12) call encode_inout_init(modl13_,data13_,vel13_, hesp13_,mask13_,epsi13_,lmbd13_,wght13_,pick13_,mmov13_,rmov13_,norm13_,dips13_,f13_,s13_,ts13_,ts13_,cc13_,rr13_,wfld13_, souz13_,sv13_,smodl13_,maps13_ ,13)
        if (nsurv >13) call encode_inout_init(modl14_,data14_,vel14_, hesp14_,mask14_,epsi14_,lmbd14_,wght14_,pick14_,mmov14_,rmov14_,norm14_,dips14_,f14_,s14_,ts14_,ts14_,cc14_,rr14_,wfld14_, souz14_,sv14_,smodl14_,maps14_ ,14)
        if (nsurv >14) call encode_inout_init(modl15_,data15_,vel15_, hesp15_,mask15_,epsi15_,lmbd15_,wght15_,pick15_,mmov15_,rmov15_,norm15_,dips15_,f15_,s15_,ts15_,ts15_,cc15_,rr15_,wfld15_, souz15_,sv15_,smodl15_,maps15_ ,15)
        if (nsurv >15) call seperr('Why do you have more than fifteen surveys??? I dont think that is economical.....Talk to ur manager!!!!!!')
        if(inv)then
                        write(0,'(A65)')'========================= Scaling / Angles   =================================='
                        write(0,*)'sscale'
                        write(0,*) sscale
                                write(0,*)'-----'
                        write(0,*)'tscale'
                                write(0,*) tscale
                                write(0,'(A65)')'End scales============================================================='
                write(0,*)'nang,dang,oang', nang, dang, oang
                write(0,*)'eps_dip',eps_dip
                                write(0,'(A65)')'End angles============================================================='
        endif
  end subroutine
!#########  
  subroutine   encode_inout_init     (modl_n_, data_n_,vel_n_,hesp_n_, mask_n_, epsi_n_, lmbd_n_, wght_n_, pick_n_, mmov_n_, rmov_n_, norm_n_, dips_n_, f_n_, s_n_, ts_n_, sd_n_, cc_n_, rr_n_,wfld_n_, souz_n_, sv_n_, sm_n_, mp_n_, isurv)
          use joint_encode_fft
          character(len=256)                    :: modl_n_, data_n_, vel_n_,mask_n_, epsi_n_, lmbd_n_, wght_n_, pick_n_, mmov_n_, rmov_n_, norm_n_, hesp_n_, dips_n_, f_n_, s_n_, ts_n_, sd_n_, cc_n_, rr_n_, wfld_n_, souz_n_, sv_n_, mp_n_, sm_n_ 
          real                                  :: eps_n, lmb_n
          integer                               :: stat
          integer                               :: isurv, i

!       mov%n=nint(1.*niter/jmov)
        mov%n=niter
        mov%o=0.
        mov%d=jmov 

        if(igrid%ahx%n>1.or.igrid%ahy%n>1.or.lsub_offset)then
                call houaxis2(modl_n_, igrid%ahx,1);call houaxis2(modl_n_, igrid%ahy,2);
                call houaxis2(modl_n_, vgrid%ax, 3);call houaxis2(modl_n_, vgrid%ay, 4); call houaxis2(modl_n_,vgrid%az, 5)
        else
                call houaxis2(modl_n_, vgrid%ax, 1);call houaxis2(modl_n_, vgrid%ay, 2); call houaxis2(modl_n_,vgrid%az, 3)
        endif
        call houaxis2(souz_n_, dgrid%asx,4);call houaxis2(souz_n_, dgrid%asy,5); call houaxis2(souz_n_, vgrid%ax, 1);call houaxis2(souz_n_, vgrid%ay, 2); call houaxis2(souz_n_,dgrid%aw, 3)
        
        if(lread_data)then
                if(isurv==1 )then;  fd1=0.; call read_datafile(fd1 (1:ndat),data1_ ); endif; if(isurv==2 )then;  fd2=0.; call read_datafile(fd2 (1:ndat),data2_ ); endif; if(isurv==3 )then;  fd3=0.; call read_datafile(fd3 (1:ndat),data3_ ); endif
                if(isurv==4 )then;  fd4=0.; call read_datafile(fd4 (1:ndat),data4_ ); endif; if(isurv==5 )then;  fd5=0.; call read_datafile(fd5 (1:ndat),data5_ ); endif; if(isurv==6 )then;  fd6=0.; call read_datafile(fd6 (1:ndat),data6_ ); endif 
                if(isurv==7 )then;  fd7=0.; call read_datafile(fd7 (1:ndat),data7_ ); endif; if(isurv==8 )then;  fd8=0.; call read_datafile(fd8 (1:ndat),data8_ ); endif; if(isurv==9 )then;  fd9=0.; call read_datafile(fd9 (1:ndat),data9_ ); endif 
                if(isurv==10)then; fd10=0.; call read_datafile(fd10(1:ndat),data10_); endif; if(isurv==11)then; fd11=0.; call read_datafile(fd11(1:ndat),data11_); endif; if(isurv==12)then; fd12=0.; call read_datafile(fd12(1:ndat),data12_); endif 
                if(isurv==13)then; fd13=0.; call read_datafile(fd13(1:ndat),data13_); endif; if(isurv==14)then; fd14=0.; call read_datafile(fd14(1:ndat),data14_); endif; if(isurv==15)then; fd15=0.; call read_datafile(fd15(1:ndat),data15_); endif 
        endif
        if(eps_vec.and.inv)then
                if(lquant)then
                        epsi0(0*nmod*nsurv+1:nmod*nsurv*1)=quantile1(int(size(fdata0)*eps_quant/100),cabs(fdata0))
                        epsi0(1*nmod*nsurv+1:nmod*nsurv*2)=quantile1(int(size(fdata0)*lmb_quant/100),cabs(fdata0))
                        !epsi0(2*nmod*nsurv+1:nmod*nsurv*3)=quantile1(int(size(fdata0)*gam_quant/100),cabs(fdata0))
                else
                        epsi0(0*nmod*nsurv+1:nmod*nsurv*1)=maxval(cabs(fdata0))/eps_denom
                        epsi0(1*nmod*nsurv+1:nmod*nsurv*2)=maxval(cabs(fdata0))/lmb_denom
                        !epsi0(2*nmod*nsurv+1:nmod*nsurv*3)=maxval(cabs(fdata0))/gam_denom
                endif
        elseif(inv)then
                if(lquant)then
                        eps=quantile1(int(size(fdata0)*eps_quant/100),cabs(fdata0))
                        lmb=quantile1(int(size(fdata0)*lmb_quant/100),cabs(fdata0))
                        gam=quantile1(int(size(fdata0)*gam_quant/100),cabs(fdata0))
                else
                        eps=maxval(cabs(fdata0))/eps_denom
                        lmb=maxval(cabs(fdata0))/lmb_denom
                        gam=maxval(cabs(fdata0))/gam_denom 
                endif
        endif
        
        !if(exist_file(mp_n_  ))call in_map  ("reed",maps0(:,:,:,:,isurv), mp_n_, isurv); !map
        if(exist_file(vel_n_ ))call in_out2d("reed",vel0 ((isurv-1)*nmod+1:isurv*nmod),  vel_n_, isurv);
        if(exist_file(dips_n_))call in_out2d("reed",dips0((isurv-1)*nmod+1:isurv*nmod), dips_n_, isurv);
        if(exist_file(sm_n_  ))then; call houaxis2(sm_n_, igrid%ax, 1);call houaxis2(sm_n_, igrid%ay, 2); call houaxis2(sm_n_,igrid%az, 3); call in_out2d("rite",0*vel0(1:nmod),sm_n_, isurv); endif
 
        if(lsft)then
                if(use_shft)then
                        if(exist_file(ts_n_))call ts_io("reed",  ts0((isurv-1)*nmod+1:isurv*nmod,:), isurv, T); 
                else
                        ts0(1:nmod,:)=0        
                        if(exist_file(ts_n_))call ts_io("rite",  ts0(1:nmod,:), isurv, T); 
                endif
        endif
        if(lcc)then
                        cc0(1:nmod,:)=0
                        if(exist_file(cc_n_))call cc_io("rite",  cc0(1:nmod,:), isurv, T); 
        endif
        if(inv)then
                if(exist_file(epsi_n_))call in_out2d("reed",epsi0((isurv-1)*nmod+1:isurv*nmod), epsi_n_, isurv); 
                if(exist_file(lmbd_n_))call in_out2d("reed",lmbd0((isurv-1)*nmod+1:isurv*nmod), lmbd_n_, isurv); 
                if(exist_file(   f_n_))call in_out2d("reed",   f0((isurv-1)*nmod+1:isurv*nmod),    f_n_, isurv); 
                if(exist_file(   s_n_))call in_out2d("reed",   s0((isurv-1)*nmod+1:isurv*nmod),    s_n_, isurv);
                call houaxis2(mmov_n_, vgrid%ax, 1);call houaxis2(mmov_n_, vgrid%ay, 2); call houaxis2(mmov_n_,vgrid%az, 3);call houaxis2(mmov_n_, mov , 4)
                call houaxis2(rmov_n_, vgrid%ax, 1);call houaxis2(rmov_n_, vgrid%ay, 2); call houaxis2(rmov_n_,vgrid%az, 3);call houaxis2(rmov_n_, mov , 4)
                call houaxis2(rmov_  , vgrid%ax, 1);call houaxis2(rmov_  , vgrid%ay, 2); call houaxis2(rmov_  ,vgrid%az, 3);call houaxis2(rmov_  , mov , 5); call auxputch ( 'n4', 'i', nsurv, rmov_); call auxputch ( 'o4', 'r', 0, rmov_); call auxputch ( 'd4', 'r', 1, rmov_)
                call houaxis2(mmov_  , vgrid%ax, 1);call houaxis2(mmov_  , vgrid%ay, 2); call houaxis2(mmov_  ,vgrid%az, 3);call houaxis2(mmov_  , mov , 5); call auxputch ( 'n4', 'i', nsurv, mmov_); call auxputch ( 'o4', 'r', 0, mmov_); call auxputch ( 'd4', 'r', 1, mmov_)
                
                sscale=rho; tscale=rho_t
               ! max_rho_t-iter*(max_rho_t-min_rho_t)/niter  
                do i=1,nint(1.*niter/dsscale)
                        sscale(1+(i-1)*dsscale:min(nint(i*dsscale),niter))=rho  *(niter-i+1)/niter
                enddo
                do i=1,nint(1.*niter/dtscale)
                        tscale(1+(i-1)*dtscale:min(nint(i*dsscale),niter))=rho_t*(niter-i+1)/niter
                enddo
        endif

        if (wfld_d_out) call wfld_output_history(wfld_n_)
        write(0,*)' | Done init...'
  end subroutine
!#####################################################  
  subroutine read_datafile(dat,dat_)
        complex, dimension (:)          :: dat
        complex, dimension (dgrid%agx%n, dgrid%agy%n, dgrid%aw%n, dgrid%asx%n, dgrid%asy%n):: data
        character(len=256)              :: dat_
        character(len=4)                :: flag
        integer, dimension(5)           :: n_cube, j_wind, n_wind, f_wind
        integer                         :: n_dim_cube, err

        n_dim_cube = 5
        n_cube = (/dgrid%agx%n             , dgrid%agy%n           , dgrid%aw%n           , dgrid%asx%n           , dgrid%asy%n/)
        n_wind = (/dgrid%agx%n             , dgrid%agy%n           , dgrid%aw%n           , dgrid%asx%n           , dgrid%asy%n/)
        j_wind = (/1                       , 1                     , 1                    , 1                     , 1          /)
        f_wind = (/0                       , 0                     , 0                    , 0                     , 0          /)

        dat=0.
        data=0
        write(0,*)size(data),ndat,size(dat)
!        write(0,*)n_cube; write(0,*)n_wind; write(0,*)j_wind; write(0,*)f_wind;

        err = sreed_window(dat_,n_dim_cube,n_cube,n_wind,f_wind,j_wind,8,data ); if (err /= 0) call seperr("rr_io2: error writing rr")
!        call sreed(data_,dat,8*size(dat))
        dat=reshape(data,(/ndat/))
        write(0,'(A6,3((E14.4,1X)))',advance='no')trim(data_),sum(data),maxval(cabs(data))
        write(0,'(A6,3((E14.4,1X)))',advance='no')trim(dat_),sum(dat),maxval(cabs(dat))
        !call srite(data_,dat,8*size(dat))
  end subroutine
!#####################################################  
  subroutine joint_encode_inout_model_init()
                call joint_adjnull_foper(F,F,modl0,fdata0)!initialize pointers to the full joint datasets
                call joint_adjnull_vel(F,F,vel0)          !initialize pointers to the full joint velocities
                if (nsurv > 0) call encode_out_model_init(modl1_ , data1_ , vel1_ , wfld1_ , m1 , v1 ,1 ); 
                if (nsurv > 1) call encode_out_model_init(modl2_ , data2_ , vel2_ , wfld2_ , m2 , v2 ,2 ); 
                if (nsurv > 2) call encode_out_model_init(modl3_ , data3_ , vel3_ , wfld3_ , m3 , v3 ,3 ); 
                if (nsurv > 3) call encode_out_model_init(modl4_ , data4_ , vel4_ , wfld4_ , m4 , v4 ,4 ); 
                if (nsurv > 4) call encode_out_model_init(modl5_ , data5_ , vel5_ , wfld5_ , m5 , v5 ,5 ); 
                if (nsurv > 5) call encode_out_model_init(modl6_ , data6_ , vel6_ , wfld6_ , m6 , v6 ,6 ); 
                if (nsurv > 6) call encode_out_model_init(modl7_ , data7_ , vel7_ , wfld7_ , m7 , v7 ,7 ); 
                if (nsurv > 7) call encode_out_model_init(modl8_ , data8_ , vel8_ , wfld8_ , m8 , v8 ,8 ); 
                if (nsurv > 8) call encode_out_model_init(modl9_ , data9_ , vel9_ , wfld9_ , m9 , v9 ,9 ); 
                if (nsurv > 9) call encode_out_model_init(modl10_, data10_, vel10_, wfld10_, m10, v10,10); 
                if (nsurv >10) call encode_out_model_init(modl11_, data11_, vel11_, wfld11_, m11, v11,11); 
                if (nsurv >11) call encode_out_model_init(modl12_, data12_, vel12_, wfld12_, m12, v12,12); 
                if (nsurv >12) call encode_out_model_init(modl13_, data13_, vel13_, wfld13_, m13, v13,13);
                if (nsurv >13) call encode_out_model_init(modl14_, data14_, vel14_, wfld14_, m14, v14,14);
                if (nsurv >14) call encode_out_model_init(modl15_, data15_, vel15_, wfld15_, m15, v15,15);
                if (nsurv >15) call seperr('You should not be here.....too many surveys')
  end subroutine
!#####################################################  
  subroutine           encode_out_model_init(modl_n_, data_n_, vel_n_, wfld_n_, modl_n, vel_n, isurv)
        character(len=256)                :: modl_n_, data_n_, vel_n_, wfld_n_
        real, dimension(:)  , pointer     :: modl_n , vel_n
        type(axis)                 , save :: ww
        integer                           :: isurv

        ww%d=dgrid%aw%d/(2*PI); ww%o=dgrid%aw%o/(2*PI); ww%n=dgrid%aw%n
        call auxinout(data_n_)
        call sep_read(modl_n, modl_n_) ;
        call sep_read( vel_n,  vel_n_) ;
        if (wfld_d_out) call wfld_output_history(wfld_n_)

        if (lfreq)then
                write(*,'(A5,I2,A15)')'data',isurv,'=======> freq!' 
                if(use_greens)then
                        call houaxis(data_n_,dgrid%agx,1);call houaxis(data_n_,dgrid%agy,2); call houaxis(data_n_,ww,5); call houaxis(data_n_,dgrid%asx,3); call houaxis(data_n_,dgrid%asy,4);
                        call auxputch("label1", "s", "geoph_x", data_n_); call auxputch("label2", "s", "geoph_y", data_n_); call auxputch("label5", "s", "freq.  ", data_n_); call auxputch("label3", "s", "shot_x" , data_n_); call auxputch("label4", "s", "shot_y" , data_n_)
                else
                        call houaxis(data_n_,dgrid%agx,1);call houaxis(data_n_,dgrid%agy,2); call houaxis(data_n_,ww,3); call houaxis(data_n_,dgrid%asx,4); call houaxis(data_n_,dgrid%asy,5);
                        call auxputch("label1", "s", "geoph_x", data_n_); call auxputch("label2", "s", "geoph_y", data_n_); call auxputch("label3", "s", "freq.  ", data_n_); call auxputch("label4", "s", "shot_x" , data_n_); call auxputch("label5", "s", "shot_y" , data_n_)
                endif
                call to_history('esize', 8, data_n_)
        else
                call houaxis(data_n_,dgrid%agx,1);call houaxis(data_n_,dgrid%agy,2); call houaxis(data_n_,dgrid%at,5); call houaxis(data_n_,dgrid%asx,3); call houaxis(data_n_,dgrid%asy,4);
                call auxputch("label1", "s", "geoph_x", data_n_)
                call auxputch("label2", "s", "geoph_y", data_n_)
                call auxputch("label5", "s", "time.  ", data_n_)
                call auxputch("label3", "s", "shot_x ", data_n_)
                call auxputch("label4", "s", "shot_y ", data_n_)
                call to_history('esize', 4, data_n_)
                write(*,*)'data=========>       time'
        endif
  end subroutine
!#####################################################  
end module
