module joint_encode_outputs
  use joint_encode_fft
  use joint_encode_adjnull
  use joint_encode_data_io
  use joint_encode_data_param
  
  implicit none 
  contains
!  #============================  
subroutine joint_encode_output()
        integer         :: stat,isurv
        real, pointer   :: norm(:)
        integer         :: iaxis
        call joint_adjnull_foper(F,F,modl0,fdata0) 
        if (.not. only_ltshift)then
                if (adj .or. inv) then
                        if (nsurv >14) then
                                call mig_io_1d(m15,15); write(0,*)'Written modl...',15,sum(m15);if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv >13) then
                                call mig_io_1d(m14,14); write(0,*)'Written modl...',14,sum(m14);if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv >12) then
                                call mig_io_1d(m13,13); write(0,*)'Written modl...',13,sum(m13);if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv >11) then
                                call mig_io_1d(m12,12); write(0,*)'Written modl...',12,sum(m12);if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv >10) then
                                call mig_io_1d(m11,11); write(0,*)'Written modl...',11,sum(m11);if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv > 9) then
                                call mig_io_1d(m10,10); write(0,*)'Written modl...',10,sum(m10);if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv > 8) then
                                call mig_io_1d(m9,9);   write(0,*)'Written modl...', 9,sum(m9); if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv > 7) then
                                call mig_io_1d(m8,8);   write(0,*)'Written modl...', 8,sum(m8); if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv > 6) then
                                call mig_io_1d(m7,7);   write(0,*)'Written modl...', 7,sum(m7); if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv > 5) then
                                call mig_io_1d(m6,6);   write(0,*)'Written modl...', 6,sum(m6); if(inv.and.all)then; mmov6=>mmov0(5*nmod+1:6*nmod,:); rmov6=>rmov0(5*nmod+1:6*nmod,:); norm=sum(abs(rmov6),1); if(exist_file(mmov6_))call sep_write(mmov6, mmov6_ ); if(exist_file(rmov6_))call sep_write(rmov6, rmov6_ ); if(exist_file(norm6_)) call sep_write(norm, norm6_); endif
                        endif        
                        if (nsurv > 4) then
                                call mig_io_1d(m5,5);   write(0,*)'Written modl...', 5,sum(m5); if(inv.and.all)then; mmov5=>mmov0(4*nmod+1:5*nmod,:); rmov5=>rmov0(4*nmod+1:5*nmod,:); norm=sum(abs(rmov5),1); if(exist_file(mmov5_))call sep_write(mmov5, mmov5_ ); if(exist_file(rmov5_))call sep_write(rmov5, rmov5_ ); if(exist_file(norm5_)) call sep_write(norm, norm5_); endif
                        endif        
                        if (nsurv > 3) then
                                call mig_io_1d(m4,4);   write(0,*)'Written modl...', 4,sum(m4); if(inv.and.all)then; mmov4=>mmov0(3*nmod+1:4*nmod,:); rmov4=>rmov0(3*nmod+1:4*nmod,:); norm=sum(abs(rmov4),1); if(exist_file(mmov4_))call sep_write(mmov4, mmov4_ ); if(exist_file(rmov4_))call sep_write(rmov4, rmov4_ ); if(exist_file(norm4_)) call sep_write(norm, norm4_); endif
                        endif        
                        if (nsurv > 2) then
                                call mig_io_1d(m3,3);   write(0,*)'Written modl...', 3,sum(m3); if(inv.and.all)then; mmov3=>mmov0(2*nmod+1:3*nmod,:); rmov3=>rmov0(2*nmod+1:3*nmod,:); norm=sum(abs(rmov3),1); if(exist_file(mmov3_))call sep_write(mmov3, mmov3_ ); if(exist_file(rmov3_))call sep_write(rmov3, rmov3_ ); if(exist_file(norm3_)) call sep_write(norm, norm3_); endif
                        endif        
                        if (nsurv > 1) then
                                call mig_io_1d(m2,2);   write(0,*)'Written modl...', 2,sum(m2); if(inv.and.all)then; mmov2=>mmov0(1*nmod+1:2*nmod,:); rmov2=>rmov0(1*nmod+1:2*nmod,:); norm=sum(abs(rmov2),1); if(exist_file(mmov2_))call sep_write(mmov2, mmov2_ ); if(exist_file(rmov2_))call sep_write(rmov2, rmov2_ ); if(exist_file(norm2_)) call sep_write(norm, norm2_); endif
                        endif        
                        if (nsurv > 0) then
                                call mig_io_1d(m1,1);   write(0,*)'Written modl...', 1,sum(m1); if(inv.and.all)then; mmov1=>mmov0(0*nmod+1:1*nmod,:); rmov1=>rmov0(0*nmod+1:1*nmod,:); norm=sum(abs(rmov1),1); if(exist_file(mmov1_))call sep_write(mmov1, mmov1_ ); if(exist_file(rmov1_))call sep_write(rmov1, rmov1_ ); if(exist_file(norm1_)) call sep_write(norm, norm1_); endif
                        endif
                else  
                        if (nsurv >14) then; call sep_write(fd15(1:ndat), data15_); write(0,*)'Writing data...',15,sum(fd15); endif 
                        if (nsurv >13) then; call sep_write(fd14(1:ndat), data14_); write(0,*)'Writing data...',14,sum(fd14); endif
                        if (nsurv >12) then; call sep_write(fd13(1:ndat), data13_); write(0,*)'Writing data...',13,sum(fd13); endif
                        if (nsurv >11) then; call sep_write(fd12(1:ndat), data12_); write(0,*)'Writing data...',12,sum(fd12); endif
                        if (nsurv >10) then; call sep_write(fd11(1:ndat), data11_); write(0,*)'Writing data...',11,sum(fd11); endif
                        if (nsurv > 9) then; call sep_write(fd10(1:ndat), data10_); write(0,*)'Writing data...',10,sum(fd10); endif
                        if (nsurv > 8) then; call sep_write(fd9 (1:ndat), data9_ ); write(0,*)'Writing data...',9 ,sum(fd9 ); endif
                        if (nsurv > 7) then; call sep_write(fd8 (1:ndat), data8_ ); write(0,*)'Writing data...',8 ,sum(fd8 ); endif
                        if (nsurv > 6) then; call sep_write(fd7 (1:ndat), data7_ ); write(0,*)'Writing data...',7 ,sum(fd7 ); endif
                        if (nsurv > 5) then; call sep_write(fd6 (1:ndat), data6_ ); write(0,*)'Writing data...',6 ,sum(fd6 ); endif
                        if (nsurv > 4) then; call sep_write(fd5 (1:ndat), data5_ ); write(0,*)'Writing data...',5 ,sum(fd5 ); endif
                        if (nsurv > 3) then; call sep_write(fd4 (1:ndat), data4_ ); write(0,*)'Writing data...',4 ,sum(fd4 ); endif 
                        if (nsurv > 2) then; call sep_write(fd3 (1:ndat), data3_ ); write(0,*)'Writing data...',3 ,sum(fd3 ); endif
                        if (nsurv > 1) then; call sep_write(fd2 (1:ndat), data2_ ); write(0,*)'Writing data...',2 ,sum(fd2 ); endif
                        if (nsurv > 0) then; call sep_write(fd1 (1:ndat), data1_ ); write(0,*)'Writing data...',1 ,sum(fd1 ); endif
                endif     
                if(exist_file(ts2_).and.lsft)then; do isurv=1,nsurv; call ts_io('rite',  ts0((isurv-1)*nmod+1:isurv*nmod,:),isurv,F);  enddo; endif
                if(exist_file(cc2_).and.lcc )then; do isurv=1,nsurv; call cc_io('rite',  cc0((isurv-1)*nmod+1:isurv*nmod,:),isurv,F);  enddo; endif
                if(exist_file(sv2_).and.lsv )then; do isurv=1,nsurv; call sv_io('rite', vel0((isurv-1)*nmod+1:isurv*nmod  ),isurv  );  enddo; endif
        else
!                if(shift_only_diff)then
!                        if(exist_file(cc2_))then; do isurv=1,nsurv; call cc_io('rite', ts0((isurv-1)*nmod+1:isurv*nmod,nshift_cycle),isurv,F); enddo; endif
!                else        
                        if(exist_file(ts2_).and.lsft)then; do isurv=1,nsurv; call ts_io('rite', ts0((isurv-1)*nmod+1:isurv*nmod,:),isurv,F);  enddo; endif
                        if(exist_file(cc2_).and.lcc )then; do isurv=1,nsurv; call cc_io('rite', cc0((isurv-1)*nmod+1:isurv*nmod,:),isurv,F);  enddo; endif
!                endif
        endif
        
!  do isurv=1,nsurv; call mig_io_1d(modl((isurv-1)*nmod+1:isurv*nmod),isurv);  write(0,*)'Written modl...',sum(modl((isurv-1)*nmod+1:isurv*nmod)); enddo;

  end subroutine
!###################################  
end module
