module joint_type
	use type_mod
	implicit none

!=================
    	type rdat;
		real   , allocatable, dimension(:)   :: d
        	character(len=256)                   :: fil ;    
	end type;
!=================
    	type cdat;
		complex, allocatable, dimension(:)   :: d
        	character(len=256)                   :: fil ;    
	end type;
!=================
    	type r2dat;
		real   , allocatable, dimension(:,:) :: d
        	character(len=256)                   :: fil ;    
	end type;
!=================
    	type c2dat;
		complex, allocatable, dimension(:,:) :: d
        	character(len=256)                   :: fil ;    
	end type;
!=================
    	type r3dat; 
		real   , allocatable, dimension(:,:,:) :: d
        	character(len=256)                     :: fil ;    
	end type;
!=================
    	type survey;
		type( rdat)				:: d, m, v, sm, sv, dips, epsi, lmbd, mask, wght, pick, norm, hesp
		type(r2dat) 				:: ts, sd, cc, rr
		type( cdat) 				:: fd 
		type(r2dat) 				:: code,csou
		type(r2dat) 				:: rmov,mmov
		type(r3dat) 				:: hess
		real , dimension(:,:,:,:,:  ), pointer  :: hes
		real , dimension(:,:,:,:,:,:), pointer  :: he
		real , dimension(:,:,:,:,:,:), pointer  :: he_
		complex,dimension(:,:,:,:,:,:), pointer :: gscd,grcd
	end type
!=================
    	type jsurvey;
        	type(survey), dimension(:),pointer 	:: surv
	end type
!=================
end module


