%clear
%load matrix
clear
disp('loading dips...');  H1=load_history('dip_vect.H');       HH1=load_data(H1);

samp=1;
d(1)=HH1.d(1)*samp;
d(2)=HH1.d(2)*samp;

 data=tan(HH1.data(1:d(1):HH1.n(1),1:d(2):HH1.n(2)));
  
 n(1)=length(1:d(1):HH1.n(1));
 n(2)=length(1:d(2):HH1.n(2));
 
 V=sin(data);V=V(:);
 U=cos(data);U=U(:);
 
 scale=0.6;
 
 xi=HH1.o(2):d(2):HH1.o(2)+d(2)*n(2)-1;
 yi=HH1.o(1):d(1):HH1.o(1)+d(1)*n(1)-1;
 [X,Y]=meshgrid(xi,yi);
 xi=X(:);
 yi=Y(:); 
 clf
 pcolor(data); hold on;
 %axis equal

 for i=1:length(U)
    if(U(i)>0.&&V(i)>0)
        U(i)=-U(i);
        V(i)=-V(i);
    end
 end
 
 uv(:,1)=-U;
 uv(:,2)=-V;
 xy(:,1)=xi;
 xy(:,2)=yi;
 
 velocity_arrows2 (xy , uv, scale, samp );

