module init_mod
  use global_params_mod
implicit none 
contains
!===========================================

subroutine wfld_z1_encode(csou_full)
        type(pro_grid)            :: pgrid   
        complex, dimension(:,:,:) :: csou_full
        integer                   :: iw
	real                      :: w, p
        real                      :: t(wgrid%asy%n,wgrid%asx%n)                      
        integer                   :: isyy,issy
        integer                   :: isxx,issx
	real                      :: ssx, ssy
        encode_='encode'
        allocate(code(dgrid%asy%n, dgrid%asx%n)); memory = memory + 4*size(code);
        if(exist_file(encode_))open (unit=50, file=trim(encode_), status='unknown')
        if(encode)then;
                if (code_it)then
                        if(random_constant)then
                                call random_seed
                                call random_number(t); t=rand_tmin+t*rand_tlim;
                                do iw = 1, wgrid%aw%n
                                        w = wgrid%aw%o + (iw-1)*wgrid%aw%d
                                        csou_full(:,:,iw)=csou_full(:,:,iw)*exp(cmplx(0,-w*t)); 
                                end do
                        endif
                        code=t
                        do isy=1,dgrid%asy%n
                                do isx=1,dgrid%asx%n
                                        write(50,*,err=15)code(isy,isx)
                                enddo
                        enddo
                else
                        if (exist_file(trim(encode_)))then
                                code=-9999
                                do isy=1,dgrid%asy%n
                                        do isx=1,dgrid%asx%n
                                                read(50,*,err=14, end=14)code(isy,isx)
                                        enddo
                                enddo
                                t=code        
                                do iw = 1, wgrid%aw%n
                                        w = wgrid%aw%o + (iw-1)*wgrid%aw%d
                                        csou_full(:,:,iw)=csou_full(:,:,iw)*exp(cmplx(0,-w*t));
                                end do
                        else
                                call seperr('No encode file found!!! check encode')
                        endif
14                      if (minval(code)==-9999) call seperr('Number of sources differ from number specified in file')
                endif
        endif
15      close (50)       

end subroutine
!#========
subroutine wfld_z1_init(wfld_slice_d,pgrid,green,iw)
        type(pro_grid)            :: pgrid   
        complex, dimension(:,:,:) :: green
        complex, dimension(:,:  ) :: wfld_slice_d
        integer                   :: iw
        integer                   :: isyy,issy
        integer                   :: isxx,issx
	real                      :: ssx, ssy
        wfld_slice_d=0.
        if(encode)then;
                if (spike)then; 
                        do issy = 1, wgrid%asy%n
                                ssy = wgrid%asy%o+(issy-1)*wgrid%asy%d; isyy=1.5 + (ssy-vgrid%ay%o)/vgrid%ay%d; 
                        do issx = 1, wgrid%asx%n
                                ssx = wgrid%asx%o+(issx-1)*wgrid%asx%d; isxx=1.5 + (ssx-vgrid%ax%o)/vgrid%ax%d;
                                wfld_slice_d(isxx,isyy)=1; 
                        end do
                        end do
                else; 
                        do issy = 1, wgrid%asy%n
                                ssy = wgrid%asy%o+(issy-1)*wgrid%asy%d; isyy=1.5 + (ssy-vgrid%ay%o)/vgrid%ay%d;
                        do issx = 1, wgrid%asx%n
                                ssx = wgrid%asx%o+(issx-1)*wgrid%asx%d; isxx=1.5 + (ssx-vgrid%ax%o)/vgrid%ax%d;
                                wfld_slice_d(isxx,isyy)=csou_full(issx,issy,iw); 
                        end do
                        end do
                endif 
        else
                if (spike)then; 
                        wfld_slice_d(pgrid%index_datpro_sx,pgrid%index_datpro_sy)=1.; 
                else; 
                        wfld_slice_d(pgrid%index_datpro_sx,pgrid%index_datpro_sy)=csou(iw); 
                endif
        endif
        !write(0,*)pgrid%index_datpro_sx,pgrid%index_datpro_sy,ggrid%index_modpro_minx,ggrid%index_modpro_maxx, ggrid%index_modpro_miny,ggrid%index_modpro_maxy
        ! write(0,*)sum(wfld_slice_d)
        green(:,:,1)=wfld_slice_d(ggrid%index_modpro_minx:ggrid%index_modpro_maxx, ggrid%index_modpro_miny:ggrid%index_modpro_maxy)
end subroutine


end module

