module joint_encode_add
 use joint_encode_params
 
 implicit none

 contains 
!#####################################################  
  subroutine joint_add(adj,add,modl,data)
  logical            :: adj, add
  real, dimension(:) :: modl, data

  if (.not. add )then
      if (adj)then;   
         if (nsurv >14) modl(14*nmod+1:15*nmod)=m15;
         if (nsurv >13) modl(13*nmod+1:14*nmod)=m14;
         if (nsurv >12) modl(12*nmod+1:13*nmod)=m13;
         if (nsurv >11) modl(11*nmod+1:12*nmod)=m12;
         if (nsurv >10) modl(10*nmod+1:11*nmod)=m11;
         if (nsurv > 9) modl( 9*nmod+1:10*nmod)=m10;
         if (nsurv > 8) modl( 8*nmod+1: 9*nmod)=m9;
         if (nsurv > 7) modl( 7*nmod+1: 8*nmod)=m8;
         if (nsurv > 6) modl( 6*nmod+1: 7*nmod)=m7;
         if (nsurv > 5) modl( 5*nmod+1: 6*nmod)=m6;
         if (nsurv > 4) modl( 4*nmod+1: 5*nmod)=m5;
         if (nsurv > 3) modl( 3*nmod+1: 4*nmod)=m4;
         if (nsurv > 2) modl( 2*nmod+1: 3*nmod)=m3;
         if (nsurv > 1) modl( 1*nmod+1: 2*nmod)=m2; 
         if (nsurv > 0) modl( 0*nmod+1: 1*nmod)=m1;
     else
         if (nsurv >14) data(14*ndat+1:15*ndat)=d15;
         if (nsurv >13) data(13*ndat+1:14*ndat)=d14;
         if (nsurv >12) data(12*ndat+1:13*ndat)=d13;
         if (nsurv >11) data(11*ndat+1:12*ndat)=d12;
         if (nsurv >10) data(10*ndat+1:11*ndat)=d11;
         if (nsurv > 9) data( 9*ndat+1:10*ndat)=d10;
         if (nsurv > 8) data( 8*ndat+1: 9*ndat)=d9;
         if (nsurv > 7) data( 7*ndat+1: 8*ndat)=d8;
         if (nsurv > 6) data( 6*ndat+1: 7*ndat)=d7;
         if (nsurv > 5) data( 5*ndat+1: 6*ndat)=d6;
         if (nsurv > 4) data( 4*ndat+1: 5*ndat)=d5;
         if (nsurv > 3) data( 3*ndat+1: 4*ndat)=d4;
         if (nsurv > 2) data( 2*ndat+1: 3*ndat)=d3;
         if (nsurv > 1) data( 1*ndat+1: 2*ndat)=d2;
         if (nsurv > 0) data( 0*ndat+1: 1*ndat)=d1;
     endif
  else
      if (adj)then;  
         if (nsurv >14) modl(14*nmod+1:15*nmod)=modl(14*nmod+1:15*nmod)+m15;
         if (nsurv >13) modl(13*nmod+1:14*nmod)=modl(13*nmod+1:14*nmod)+m14;
         if (nsurv >12) modl(12*nmod+1:13*nmod)=modl(12*nmod+1:13*nmod)+m13;
         if (nsurv >11) modl(11*nmod+1:12*nmod)=modl(11*nmod+1:12*nmod)+m12;
         if (nsurv >10) modl(10*nmod+1:11*nmod)=modl(10*nmod+1:11*nmod)+m11;
         if (nsurv > 9) modl( 9*nmod+1:10*nmod)=modl( 9*nmod+1:10*nmod)+m10;
         if (nsurv > 8) modl( 8*nmod+1: 9*nmod)=modl( 8*nmod+1: 9*nmod)+m9;
         if (nsurv > 7) modl( 7*nmod+1: 8*nmod)=modl( 7*nmod+1: 8*nmod)+m8;
         if (nsurv > 6) modl( 6*nmod+1: 7*nmod)=modl( 6*nmod+1: 7*nmod)+m7;
         if (nsurv > 5) modl( 5*nmod+1: 6*nmod)=modl( 5*nmod+1: 6*nmod)+m6;
         if (nsurv > 4) modl( 4*nmod+1: 5*nmod)=modl( 4*nmod+1: 5*nmod)+m5;
         if (nsurv > 3) modl( 3*nmod+1: 4*nmod)=modl( 3*nmod+1: 4*nmod)+m4;
         if (nsurv > 2) modl( 2*nmod+1: 3*nmod)=modl( 2*nmod+1: 3*nmod)+m3;
         if (nsurv > 1) modl( 1*nmod+1: 2*nmod)=modl( 1*nmod+1: 2*nmod)+m2; 
         if (nsurv > 0) modl( 0*nmod+1: 1*nmod)=modl( 0*nmod+1: 1*nmod)+m1;
     else
         if (nsurv >14) data(14*ndat+1:15*ndat)=data(14*ndat+1:15*ndat)+d15;
         if (nsurv >13) data(13*ndat+1:14*ndat)=data(13*ndat+1:14*ndat)+d14;
         if (nsurv >12) data(12*ndat+1:13*ndat)=data(12*ndat+1:13*ndat)+d13;
         if (nsurv >11) data(11*ndat+1:12*ndat)=data(11*ndat+1:12*ndat)+d12;
         if (nsurv >10) data(10*ndat+1:11*ndat)=data(10*ndat+1:11*ndat)+d11;
         if (nsurv > 9) data( 9*ndat+1:10*ndat)=data( 9*ndat+1:10*ndat)+d10;
         if (nsurv > 8) data( 8*ndat+1: 9*ndat)=data( 8*ndat+1: 9*ndat)+d9;
         if (nsurv > 7) data( 7*ndat+1: 8*ndat)=data( 7*ndat+1: 8*ndat)+d8;
         if (nsurv > 6) data( 6*ndat+1: 7*ndat)=data( 6*ndat+1: 7*ndat)+d7;
         if (nsurv > 5) data( 5*ndat+1: 6*ndat)=data( 5*ndat+1: 6*ndat)+d6;
         if (nsurv > 4) data( 4*ndat+1: 5*ndat)=data( 4*ndat+1: 5*ndat)+d5;
         if (nsurv > 3) data( 3*ndat+1: 4*ndat)=data( 3*ndat+1: 4*ndat)+d4;
         if (nsurv > 2) data( 2*ndat+1: 3*ndat)=data( 2*ndat+1: 3*ndat)+d3;
         if (nsurv > 1) data( 1*ndat+1: 2*ndat)=data( 1*ndat+1: 2*ndat)+d2;
         if (nsurv > 0) data( 0*ndat+1: 1*ndat)=data( 0*ndat+1: 1*ndat)+d1;
     endif
  endif
  end subroutine

!#####################################################  
  subroutine joint_add_oper(adj,add,modl,data)
  logical            :: adj, add
  real, dimension(:) :: modl, data

  if (.not. add )then
      if (adj)then;  
         if (nsurv >14) modl(14*nmod+1:15*nmod)=m15;
         if (nsurv >13) modl(13*nmod+1:14*nmod)=m14;
         if (nsurv >12) modl(12*nmod+1:13*nmod)=m13;
         if (nsurv >11) modl(11*nmod+1:12*nmod)=m12;
         if (nsurv >10) modl(10*nmod+1:11*nmod)=m11;
         if (nsurv > 9) modl( 9*nmod+1:10*nmod)=m10;
         if (nsurv > 8) modl( 8*nmod+1: 9*nmod)=m9;
         if (nsurv > 7) modl( 7*nmod+1: 8*nmod)=m8;
         if (nsurv > 6) modl( 6*nmod+1: 7*nmod)=m7;
         if (nsurv > 5) modl( 5*nmod+1: 6*nmod)=m6;
         if (nsurv > 4) modl( 4*nmod+1: 5*nmod)=m5;
         if (nsurv > 3) modl( 3*nmod+1: 4*nmod)=m4;
         if (nsurv > 2) modl( 2*nmod+1: 3*nmod)=m3;
         if (nsurv > 1) modl( 1*nmod+1: 2*nmod)=m2; 
         if (nsurv > 0) modl( 0*nmod+1: 1*nmod)=m1;
     else
         if (nsurv >14) data(14*ndat+1:15*ndat)=d15;
         if (nsurv >13) data(13*ndat+1:14*ndat)=d14;
         if (nsurv >12) data(12*ndat+1:13*ndat)=d13;
         if (nsurv >11) data(11*ndat+1:12*ndat)=d12;
         if (nsurv >10) data(10*ndat+1:11*ndat)=d11;
         if (nsurv > 9) data( 9*ndat+1:10*ndat)=d10;
         if (nsurv > 8) data( 8*ndat+1: 9*ndat)=d9;
         if (nsurv > 7) data( 7*ndat+1: 8*ndat)=d8;
         if (nsurv > 6) data( 6*ndat+1: 7*ndat)=d7;
         if (nsurv > 5) data( 5*ndat+1: 6*ndat)=d6;
         if (nsurv > 4) data( 4*ndat+1: 5*ndat)=d5;
         if (nsurv > 3) data( 3*ndat+1: 4*ndat)=d4;
         if (nsurv > 2) data( 2*ndat+1: 3*ndat)=d3;
         if (nsurv > 1) data( 1*ndat+1: 2*ndat)=d2;
         if (nsurv > 0) data( 0*ndat+1: 1*ndat)=d1;
     endif
  else
      if (adj)then;  
         if (nsurv >14) modl(14*nmod+1:15*nmod)=modl(14*nmod+1:15*nmod)+m15;
         if (nsurv >13) modl(13*nmod+1:14*nmod)=modl(13*nmod+1:14*nmod)+m14;
         if (nsurv >12) modl(12*nmod+1:13*nmod)=modl(12*nmod+1:13*nmod)+m13;
         if (nsurv >11) modl(11*nmod+1:12*nmod)=modl(11*nmod+1:12*nmod)+m12;
         if (nsurv >10) modl(10*nmod+1:11*nmod)=modl(10*nmod+1:11*nmod)+m11;
         if (nsurv > 9) modl( 9*nmod+1:10*nmod)=modl( 9*nmod+1:10*nmod)+m10;
         if (nsurv > 8) modl( 8*nmod+1: 9*nmod)=modl( 8*nmod+1: 9*nmod)+m9;
         if (nsurv > 7) modl( 7*nmod+1: 8*nmod)=modl( 7*nmod+1: 8*nmod)+m8;
         if (nsurv > 6) modl( 6*nmod+1: 7*nmod)=modl( 6*nmod+1: 7*nmod)+m7;
         if (nsurv > 5) modl( 5*nmod+1: 6*nmod)=modl( 5*nmod+1: 6*nmod)+m6;
         if (nsurv > 4) modl( 4*nmod+1: 5*nmod)=modl( 4*nmod+1: 5*nmod)+m5;
         if (nsurv > 3) modl( 3*nmod+1: 4*nmod)=modl( 3*nmod+1: 4*nmod)+m4;
         if (nsurv > 2) modl( 2*nmod+1: 3*nmod)=modl( 2*nmod+1: 3*nmod)+m3;
         if (nsurv > 1) modl( 1*nmod+1: 2*nmod)=modl( 1*nmod+1: 2*nmod)+m2; 
         if (nsurv > 0) modl( 0*nmod+1: 1*nmod)=modl( 0*nmod+1: 1*nmod)+m1;
     else
         if (nsurv >14) data(14*ndat+1:15*ndat)=data(14*ndat+1:15*ndat)+d15;
         if (nsurv >13) data(13*ndat+1:14*ndat)=data(13*ndat+1:14*ndat)+d14;
         if (nsurv >12) data(12*ndat+1:13*ndat)=data(12*ndat+1:13*ndat)+d13;
         if (nsurv >11) data(11*ndat+1:12*ndat)=data(11*ndat+1:12*ndat)+d12;
         if (nsurv >10) data(10*ndat+1:11*ndat)=data(10*ndat+1:11*ndat)+d11;
         if (nsurv > 9) data( 9*ndat+1:10*ndat)=data( 9*ndat+1:10*ndat)+d10;
         if (nsurv > 8) data( 8*ndat+1: 9*ndat)=data( 8*ndat+1: 9*ndat)+d9;
         if (nsurv > 7) data( 7*ndat+1: 8*ndat)=data( 7*ndat+1: 8*ndat)+d8;
         if (nsurv > 6) data( 6*ndat+1: 7*ndat)=data( 6*ndat+1: 7*ndat)+d7;
         if (nsurv > 5) data( 5*ndat+1: 6*ndat)=data( 5*ndat+1: 6*ndat)+d6;
         if (nsurv > 4) data( 4*ndat+1: 5*ndat)=data( 4*ndat+1: 5*ndat)+d5;
         if (nsurv > 3) data( 3*ndat+1: 4*ndat)=data( 3*ndat+1: 4*ndat)+d4;
         if (nsurv > 2) data( 2*ndat+1: 3*ndat)=data( 2*ndat+1: 3*ndat)+d3;
         if (nsurv > 1) data( 1*ndat+1: 2*ndat)=data( 1*ndat+1: 2*ndat)+d2;
         if (nsurv > 0) data( 0*ndat+1: 1*ndat)=data( 0*ndat+1: 1*ndat)+d1;
     endif
  endif
  end subroutine
   !#####################################################  
  subroutine joint_add_link(adj,fwd,modl,data)
        logical            :: adj,  fwd
        real, dimension(:) :: modl, data
!        if (adj)then
!        else
!                m1=mod1-mod2
!                m1=mod1-mod2
!        endif        
!        if (nsurv > 5) modl6=modl6+modl5
!        if (nsurv > 4) modl5=modl5+modl4;
!        if (nsurv > 3) modl4=modl4+modl3;
!        if (nsurv > 2) modl3=modl3+modl2;
!        if (nsurv > 1) modl2=modl2+modl1;
!        if (nsurv > 0) modl1=modl1
!   else
!        if (nsurv > 5) modl6=modl6-modl5;
!        if (nsurv > 4) modl5=modl5-modl4;
!        if (nsurv > 3) modl4=modl4-modl3;
!        if (nsurv > 2) modl3=modl3-modl2;
!        if (nsurv > 1) modl2=modl2-modl1;
!        if (nsurv > 0) modl1=modl1
!  endif        
  end subroutine
end module
