module joint_encode_sx
        use joint_encode_params
        use random

        implicit none 
contains
!#########################################################################################################
  subroutine joint_encode_all()
        integer           :: iw,itx,ity
        real              :: w, p
        real              :: t (wgrid%asx%n,wgrid%asy%n)                      
        real              :: t1(wgrid%asx%n,wgrid%asy%n,nsurv)                      
        integer           :: isyy,issy, is
        integer           :: isxx,issx
        real              :: ssx, ssy
        real              :: code(wgrid%asx%n,wgrid%asy%n)
        real              :: ran


        if(nsurv>0 )then;call from_param("code1"  ,code1_  ,'code1'  ); open (unit=51, file=trim(code1_)  , status='unknown');endif
        if(nsurv>1 )then;call from_param("code2"  ,code2_  ,'code2'  ); open (unit=52, file=trim(code2_)  , status='unknown');endif
        if(nsurv>2 )then;call from_param("code3"  ,code3_  ,'code3'  ); open (unit=53, file=trim(code3_)  , status='unknown');endif
        if(nsurv>3 )then;call from_param("code4"  ,code4_  ,'code4'  ); open (unit=54, file=trim(code4_)  , status='unknown');endif
        if(nsurv>4 )then;call from_param("code5"  ,code5_  ,'code5'  ); open (unit=55, file=trim(code5_)  , status='unknown');endif
        if(nsurv>5 )then;call from_param("code6"  ,code6_  ,'code6'  ); open (unit=56, file=trim(code6_)  , status='unknown');endif
        if(nsurv>6 )then;call from_param("code7"  ,code7_  ,'code7'  ); open (unit=57, file=trim(code7_)  , status='unknown');endif
        if(nsurv>7 )then;call from_param("code8"  ,code8_  ,'code8'  ); open (unit=58, file=trim(code8_)  , status='unknown');endif
        if(nsurv>8 )then;call from_param("code9"  ,code9_  ,'code9'  ); open (unit=59, file=trim(code9_)  , status='unknown');endif
        if(nsurv>9 )then;call from_param("code10" ,code10_ ,'code10' ); open (unit=60, file=trim(code10_) , status='unknown');endif
        if(nsurv>10)then;call from_param("code11" ,code11_ ,'code11' ); open (unit=61, file=trim(code11_) , status='unknown');endif
        if(nsurv>11)then;call from_param("code12" ,code12_ ,'code12' ); open (unit=62, file=trim(code12_) , status='unknown');endif
        if(nsurv>12)then;call from_param("code13" ,code13_ ,'code13' ); open (unit=63, file=trim(code13_) , status='unknown');endif
        if(nsurv>13)then;call from_param("code14" ,code14_ ,'code14' ); open (unit=64, file=trim(code14_) , status='unknown');endif
        if(nsurv>14)then;call from_param("code15" ,code15_ ,'code15' ); open (unit=65, file=trim(code15_) , status='unknown');endif
        !
        if(nsurv>0 )then;call from_param("sshft1" ,sshft1_ ,'sshft1' ); open (unit=71, file=trim(sshft1_) , status='unknown');endif
        if(nsurv>1 )then;call from_param("sshft2" ,sshft2_ ,'sshft2' ); open (unit=72, file=trim(sshft2_) , status='unknown');endif
        if(nsurv>2 )then;call from_param("sshft3" ,sshft3_ ,'sshft3' ); open (unit=73, file=trim(sshft3_) , status='unknown');endif
        if(nsurv>3 )then;call from_param("sshft4" ,sshft4_ ,'sshft4' ); open (unit=74, file=trim(sshft4_) , status='unknown');endif
        if(nsurv>4 )then;call from_param("sshft5" ,sshft5_ ,'sshft5' ); open (unit=75, file=trim(sshft5_) , status='unknown');endif
        if(nsurv>5 )then;call from_param("sshft6" ,sshft6_ ,'sshft6' ); open (unit=76, file=trim(sshft6_) , status='unknown');endif
        if(nsurv>6 )then;call from_param("sshft7" ,sshft7_ ,'sshft7' ); open (unit=77, file=trim(sshft7_) , status='unknown');endif
        if(nsurv>7 )then;call from_param("sshft8" ,sshft8_ ,'sshft8' ); open (unit=78, file=trim(sshft8_) , status='unknown');endif
        if(nsurv>8 )then;call from_param("sshft9" ,sshft9_ ,'sshft9' ); open (unit=79, file=trim(sshft9_) , status='unknown');endif
        if(nsurv>9 )then;call from_param("sshft10",sshft10_,'sshft10'); open (unit=80, file=trim(sshft10_), status='unknown');endif
        if(nsurv>10)then;call from_param("sshft11",sshft11_,'sshft11'); open (unit=81, file=trim(sshft11_), status='unknown');endif
        if(nsurv>11)then;call from_param("sshft12",sshft12_,'sshft12'); open (unit=82, file=trim(sshft12_), status='unknown');endif
        if(nsurv>12)then;call from_param("sshft13",sshft13_,'sshft13'); open (unit=83, file=trim(sshft13_), status='unknown');endif
        if(nsurv>13)then;call from_param("sshft14",sshft14_,'sshft14'); open (unit=84, file=trim(sshft14_), status='unknown');endif
        if(nsurv>14)then;call from_param("sshft15",sshft15_,'sshft15'); open (unit=85, file=trim(sshft15_), status='unknown');endif

        code0=0.;sshft0=cmplx(0.,0.);
        code1 =>code0(:,:,1);    sshft1 =>sshft0(:,:,1);
        code2 =>code0(:,:,2);    sshft2 =>sshft0(:,:,2);
        code3 =>code0(:,:,3);    sshft3 =>sshft0(:,:,3);
        code4 =>code0(:,:,4);    sshft4 =>sshft0(:,:,4);
        code5 =>code0(:,:,5);	 sshft5 =>sshft0(:,:,5);
        code6 =>code0(:,:,6);    sshft6 =>sshft0(:,:,6);
        code7 =>code0(:,:,7);    sshft7 =>sshft0(:,:,7);
        code8 =>code0(:,:,8);    sshft8 =>sshft0(:,:,8);
        code9 =>code0(:,:,9);    sshft9 =>sshft0(:,:,9);
        code10=>code0(:,:,10);   sshft10=>sshft0(:,:,10);
        code11=>code0(:,:,11);   sshft11=>sshft0(:,:,11);
        code12=>code0(:,:,12);   sshft12=>sshft0(:,:,12);
        code13=>code0(:,:,13);   sshft13=>sshft0(:,:,13);
        code14=>code0(:,:,14);   sshft14=>sshft0(:,:,14);
        code15=>code0(:,:,15);   sshft15=>sshft0(:,:,15);
        code0=0.;sshft0=cmplx(0.,0.);

        if(encode)then;
                if (code_it)then
                        if(random_constant)then
                            do is=1,nsurv
                                if(lsame_time.and.is>1)then 
                                        !use same timing for all shots
                                else
                                        do ity=1,size(t,2)
                                        do itx=1,size(t,1)
                                                do i=1,2
                                                        j=itx*ity*is*i
                                                        call random_seed(j)
                                                        call random_number(ran)
                                                enddo
                                                t(itx,ity)=abs(ran)
                                        enddo
                                        enddo
                                        t=t/maxval(t);
                                        t=rand_tmin+t*rand_tlim;
                                        t(nsurv,1)=minval(t)
                                endif
                                do iw = 1, wgrid%aw%n
                                        w = wgrid%aw%o + (iw-1)*wgrid%aw%d
                                        csou0(:,:,iw,is)=csou_full(:,:,iw)*exp(cmplx(0,-w*t)); 
                                end do
                                if(verb>6)then
                                        write(0,'(A30)')'Delay times (ms)'
                                        write(0,'(10(E14.5,2x))')t
                                endif        
                                if(is==1)then;  csou1 =>csou0(:,:,:,1) ;code1=t ;endif
                                if(is==2)then;  csou2 =>csou0(:,:,:,2) ;code2=t ;endif 
                                if(is==3)then;  csou3 =>csou0(:,:,:,3) ;code3=t ;endif
                                if(is==4)then;  csou4 =>csou0(:,:,:,4) ;code4=t ;endif 
                                if(is==5)then;  csou5 =>csou0(:,:,:,5) ;code5=t ;endif
                                if(is==6)then;  csou6 =>csou0(:,:,:,6) ;code6=t ;endif
                                if(is==7)then;  csou7 =>csou0(:,:,:,7) ;code7=t ;endif
                                if(is==8)then;  csou8 =>csou0(:,:,:,8) ;code8=t ;endif
                                if(is==9)then;  csou9 =>csou0(:,:,:,9) ;code9=t ;endif
                                if(is==10)then; csou10=>csou0(:,:,:,10);code10=t;endif
                                if(is==11)then; csou11=>csou0(:,:,:,11);code11=t;endif
                                if(is==12)then; csou12=>csou0(:,:,:,12);code12=t;endif
                                if(is==13)then; csou13=>csou0(:,:,:,13);code13=t;endif
                                if(is==14)then; csou14=>csou0(:,:,:,14);code14=t;endif
                                if(is==15)then; csou15=>csou0(:,:,:,15);code15=t;endif
                            end do
                        elseif(linear_phase)then
                            p=linear_tlim/((wgrid%asx%n-1)*wgrid%asx%d)
                            do is=1,nsurv
                                if(lsame_time.and.is>1)then
                                        !use same timing for all shots
                                else
                                        do ity=1,size(t,2)
                                        do itx=1,nint(size(t,1)/2.)
                                                t(itx,ity)=linear_tmin-p*(itx-1)*wgrid%asx%d
                                                t(min(wgrid%asx%n,itx+nint(size(t,1)/2.)),ity)=linear_tmin-p*(itx-1)*wgrid%asx%d
                                        enddo
                                        enddo
                                        !rand_tmin=0.
                                        !t=t/maxval(t);
                                        !t=rand_tmin+t*rand_tlim;
                                endif
                                do iw = 1, wgrid%aw%n
                                        w = wgrid%aw%o + (iw-1)*wgrid%aw%d
                                        csou0(:,:,iw,is)=csou_full(:,:,iw)*exp(cmplx(0,-w*t));
                                end do
                                if(is==1)then;  csou1 =>csou0(:,:,:,1) ;code1=t ;endif
                                if(is==2)then;  csou2 =>csou0(:,:,:,2) ;code2=t ;endif 
                                if(is==3)then;  csou3 =>csou0(:,:,:,3) ;code3=t ;endif
                                if(is==4)then;  csou4 =>csou0(:,:,:,4) ;code4=t ;endif 
                                if(is==5)then;  csou5 =>csou0(:,:,:,5) ;code5=t ;endif
                                if(is==6)then;  csou6 =>csou0(:,:,:,6) ;code6=t ;endif
                                if(is==7)then;  csou7 =>csou0(:,:,:,7) ;code7=t ;endif
                                if(is==8)then;  csou8 =>csou0(:,:,:,8) ;code8=t ;endif
                                if(is==9)then;  csou9 =>csou0(:,:,:,9) ;code9=t ;endif
                                if(is==10)then; csou10=>csou0(:,:,:,10);code10=t;endif
                                if(is==11)then; csou11=>csou0(:,:,:,11);code11=t;endif
                                if(is==12)then; csou12=>csou0(:,:,:,12);code12=t;endif
                                if(is==13)then; csou13=>csou0(:,:,:,13);code13=t;endif
                                if(is==14)then; csou14=>csou0(:,:,:,14);code14=t;endif
                                if(is==15)then; csou15=>csou0(:,:,:,15);code15=t;endif
                            end do
                        endif
1                           if (sbase1 )then;csou1=csou2; write(0,*)'Base and monitor',1,' have the same encoding'
                        elseif (sbase2 )then;csou1=csou3; write(0,*)'Base and monitor',2,' have the same encoding'
                        elseif (sbase3 )then;csou1=csou4;
                        elseif (sbase4 )then;csou1=csou5;
                        elseif (sbase5 )then;csou1=csou6; 
                        elseif (sbase6 )then;csou1=csou7; 
                        elseif (sbase7 )then;csou1=csou8; 
                        elseif (sbase8 )then;csou1=csou9; 
                        elseif (sbase9 )then;csou1=csou10; 
                        elseif (sbase10)then;csou1=csou11; 
                        elseif (sbase11)then;csou1=csou12; 
                        elseif (sbase12)then;csou1=csou13; 
                        elseif (sbase13)then;csou1=csou14; 
                        elseif (sbase14)then;csou1=csou15; endif  
                        do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(51,*,err=21)code1 (isx,isy); enddo; enddo
21                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(52,*,err=22)code2 (isx,isy); enddo; enddo
22                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(53,*,err=23)code3 (isx,isy); enddo; enddo
23                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(54,*,err=24)code4 (isx,isy); enddo; enddo
24                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(55,*,err=25)code5 (isx,isy); enddo; enddo
25                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(56,*,err=26)code6 (isx,isy); enddo; enddo
26                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(57,*,err=27)code7 (isx,isy); enddo; enddo
27                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(58,*,err=28)code8 (isx,isy); enddo; enddo
28                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(59,*,err=29)code9 (isx,isy); enddo; enddo
29                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(60,*,err=30)code10(isx,isy); enddo; enddo
30                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(61,*,err=31)code11(isx,isy); enddo; enddo
31                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(62,*,err=32)code12(isx,isy); enddo; enddo
32                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(63,*,err=33)code13(isx,isy); enddo; enddo
33                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(64,*,err=34)code14(isx,isy); enddo; enddo
34                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(65,*,err=35)code15(isx,isy); enddo; enddo
                else    
                        do is=1,nsurv
                                code=-9999
                                do isy=1,wgrid%asy%n
                                        do isx=1,wgrid%asx%n
                                                if(is==1 )then;read(51,*,err=41, end=41)code1 (isx,isy); code(isx,isy)=code1 (isx,isy);endif 
41                                              if(is==2 )then;read(52,*,err=42, end=42)code2 (isx,isy); code(isx,isy)=code2 (isx,isy);endif 
42                                              if(is==3 )then;read(53,*,err=43, end=43)code3 (isx,isy); code(isx,isy)=code3 (isx,isy);endif
43                                              if(is==4 )then;read(54,*,err=44, end=44)code4 (isx,isy); code(isx,isy)=code4 (isx,isy);endif
44                                              if(is==5 )then;read(55,*,err=45, end=45)code5 (isx,isy); code(isx,isy)=code5 (isx,isy);endif
45                                              if(is==6 )then;read(56,*,err=46, end=46)code6 (isx,isy); code(isx,isy)=code6 (isx,isy);endif
46                                              if(is==7 )then;read(57,*,err=47, end=47)code7 (isx,isy); code(isx,isy)=code7 (isx,isy);endif
47                                              if(is==8 )then;read(58,*,err=48, end=48)code8 (isx,isy); code(isx,isy)=code8 (isx,isy);endif
48                                              if(is==9 )then;read(59,*,err=49, end=49)code9 (isx,isy); code(isx,isy)=code9 (isx,isy);endif
49                                              if(is==10)then;read(60,*,err=50, end=50)code10(isx,isy); code(isx,isy)=code10(isx,isy);endif
50                                              if(is==11)then;read(61,*,err=51, end=51)code11(isx,isy); code(isx,isy)=code11(isx,isy);endif
51                                              if(is==12)then;read(62,*,err=52, end=52)code12(isx,isy); code(isx,isy)=code12(isx,isy);endif
52                                              if(is==13)then;read(63,*,err=53, end=53)code13(isx,isy); code(isx,isy)=code13(isx,isy);endif
53                                              if(is==14)then;read(64,*,err=54, end=54)code14(isx,isy); code(isx,isy)=code14(isx,isy);endif
54                                              if(is==15)then;read(65,*,err=55, end=55)code15(isx,isy); code(isx,isy)=code15(isx,isy);endif
                                        enddo
                                enddo 
55                              if (minval(code)==-9999) call seperr('Number of sources differ from number specified in file')
                                t=code
                                do iw = 1, wgrid%aw%n
                                        w = wgrid%aw%o + (iw-1)*wgrid%aw%d 
                                        csou0(:,:,iw,is)=csou_full(:,:,iw)*exp(cmplx(0,-w*t));
                                end do 
                        enddo
                endif
        else
            do is=1,nsurv
                csou0(:,:,:,is)=csou_full(:,:,:);
                if(is==1 )then; csou1 =>csou0(:,:,:,1) ;code1= t;endif;                if(is==2 )then; csou2 =>csou0(:,:,:,2) ;code2 =t;endif; 
                if(is==3 )then; csou3 =>csou0(:,:,:,3) ;code3 =t;endif;                if(is==4 )then; csou4 =>csou0(:,:,:,4) ;code4 =t;endif; 
                if(is==5 )then; csou5 =>csou0(:,:,:,5) ;code5 =t;endif;                if(is==6 )then; csou6 =>csou0(:,:,:,6) ;code6 =t;endif;
                if(is==7 )then; csou7 =>csou0(:,:,:,7) ;code7 =t;endif;                if(is==8 )then; csou8 =>csou0(:,:,:,8) ;code8 =t;endif;
                if(is==9 )then; csou9 =>csou0(:,:,:,9) ;code9 =t;endif;                if(is==10)then; csou10=>csou0(:,:,:,10);code10=t;endif;
                if(is==11)then; csou11=>csou0(:,:,:,11);code11=t;endif;                if(is==12)then; csou12=>csou0(:,:,:,12);code12=t;endif;
                if(is==13)then; csou13=>csou0(:,:,:,13);code13=t;endif;                if(is==14)then; csou14=>csou0(:,:,:,14);code14=t;endif;
                if(is==15)then; csou15=>csou0(:,:,:,15);code15=t;endif;
            end do   
        endif
35      if(exist_file(code1_ ))close (51);         if(exist_file(code2_ ))close (52);         if(exist_file(code3_ ))close (53); 
        if(exist_file(code4_ ))close (54);         if(exist_file(code5_ ))close (55);         if(exist_file(code6_ ))close (56); 
        if(exist_file(code7_ ))close (57);         if(exist_file(code8_ ))close (58);         if(exist_file(code9_ ))close (59); 
        if(exist_file(code10_))close (60);         if(exist_file(code11_))close (62);         if(exist_file(code12_))close (63); 
        if(exist_file(code13_))close (63);         if(exist_file(code14_))close (64);         if(exist_file(code15_))close (65); 

        if(lshft0)then
                if(sshft_it)then
                        do is=2,nsurv        
                                do isy=1,wgrid%asy%n
                                        do isx=1,wgrid%asx%n     
                                                sshft0(isx,isy,is)=(random_normal())
                                        enddo
                                enddo
                                sshft0(:,:,is)=sshft0(:,:,is)/max(1.,maxval(cabs(sshft0(:,:,is))))*sshft_lmt;
                                sshft0(:,:,is)=sshft0(:,:,is)/max(1.,maxval(cabs(sshft0(:,:,is))))*sshft_lmt;
                        enddo
                        sshft0(1           ,1,:)=0.
                        sshft0(wgrid%asx%n ,1,:)=0.
                        do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(71,*,err=61)sshft1 (isx,isy); enddo; enddo
61                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(72,*,err=62)sshft2 (isx,isy); enddo; enddo
62                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(73,*,err=63)sshft3 (isx,isy); enddo; enddo
63                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(74,*,err=64)sshft4 (isx,isy); enddo; enddo
64                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(75,*,err=65)sshft5 (isx,isy); enddo; enddo
65                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(76,*,err=66)sshft6 (isx,isy); enddo; enddo
66                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(77,*,err=67)sshft7 (isx,isy); enddo; enddo
67                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(78,*,err=68)sshft8 (isx,isy); enddo; enddo
68                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(79,*,err=69)sshft9 (isx,isy); enddo; enddo
69                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(80,*,err=70)sshft10(isx,isy); enddo; enddo
70                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(81,*,err=71)sshft11(isx,isy); enddo; enddo
71                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(82,*,err=72)sshft12(isx,isy); enddo; enddo
72                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(83,*,err=73)sshft13(isx,isy); enddo; enddo
73                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(84,*,err=74)sshft14(isx,isy); enddo; enddo
74                      do isy=1,wgrid%asy%n; do isx=1,wgrid%asx%n; write(85,*,err=75)sshft15(isx,isy); enddo; enddo
                else
                        do is=2,nsurv
                                do isy=1,wgrid%asy%n
                                        do isx=1,wgrid%asx%n
                                                if(is==1 )then;read(71,*,err=81, end=81)sshft1 (isx,isy);endif 
81                                              if(is==2 )then;read(72,*,err=82, end=82)sshft2 (isx,isy);endif 
82                                              if(is==3 )then;read(73,*,err=83, end=83)sshft3 (isx,isy);endif 
83                                              if(is==4 )then;read(74,*,err=84, end=84)sshft4 (isx,isy);endif  
84                                              if(is==5 )then;read(75,*,err=85, end=85)sshft5 (isx,isy);endif 
85                                              if(is==6 )then;read(76,*,err=86, end=86)sshft6 (isx,isy);endif 
86                                              if(is==7 )then;read(77,*,err=87, end=87)sshft7 (isx,isy);endif 
87                                              if(is==8 )then;read(78,*,err=88, end=88)sshft8 (isx,isy);endif 
88                                              if(is==9 )then;read(79,*,err=89, end=89)sshft9 (isx,isy);endif 
89                                              if(is==10)then;read(80,*,err=90, end=90)sshft10(isx,isy);endif 
90                                              if(is==11)then;read(81,*,err=91, end=91)sshft11(isx,isy);endif 
91                                              if(is==12)then;read(82,*,err=92, end=92)sshft12(isx,isy);endif
92                                              if(is==13)then;read(83,*,err=93, end=93)sshft13(isx,isy);endif
93                                              if(is==14)then;read(84,*,err=94, end=94)sshft14(isx,isy);endif
94                                              if(is==15)then;read(85,*,err=75, end=75)sshft15(isx,isy);endif
                                        enddo
                                enddo
                        enddo
                endif
        endif
write(0,'(A65)')'========================= Shot shifts =================================='
if(sum(int(real(sshft0)))/=0)then;write(0,*)'x-shot-shifts'; write(0,*) int(real(sshft0));endif
if(sum(int(aimag(sshft0)))/=0)then;write(0,*)'y-shot-shifts'; write(0,*) int(real(sshft0));endif
write(0,'(A65)')'End wavelet============================================================='

75      write(0,*)'Done initializing shot shifts'
        if(exist_file(sshft1_ ))close (71);        if(exist_file(sshft2_ ))close (72);        if(exist_file(sshft3_ ))close (73); 
        if(exist_file(sshft4_ ))close (74);        if(exist_file(sshft5_ ))close (75);        if(exist_file(sshft6_ ))close (76); 
        if(exist_file(sshft7_ ))close (77);        if(exist_file(sshft8_ ))close (78);        if(exist_file(sshft9_ ))close (79); 
        if(exist_file(sshft10_))close (80);        if(exist_file(sshft11_))close (81);        if(exist_file(sshft12_))close (82); 
        if(exist_file(sshft13_))close (83);        if(exist_file(sshft14_))close (84);        if(exist_file(sshft15_))close (85); 
  end subroutine

  subroutine data_encode_sum()
        if(use_greens)then
                call from_param("ngx", dgrid%agx%n,  min(ggrid%ax_surf%n,vgrid%ax%n));call from_param("dgx", dgrid%agx%d,  ggrid%ax_surf%d);call from_param("ogx", dgrid%agx%o, max(ggrid%ax_surf%o,vgrid%ax%o))
                call from_param("ngy", dgrid%agy%n,  min(ggrid%ay_surf%n,vgrid%ay%n));call from_param("dgy", dgrid%agy%d,  ggrid%ay_surf%d);call from_param("ogy", dgrid%agy%o, max(ggrid%ay_surf%o,vgrid%ay%o))

                call from_param("nsx", dgrid%asx%n,                1);call from_param("dsx", dgrid%asx%d,  dgrid%agx%d    );call from_param("osx", dgrid%asx%o, ggrid%ax_modl%o+(ggrid%ax_modl%n-1)/2*ggrid%ax_modl%d)  
                call from_param("nsy", dgrid%asy%n,                1);call from_param("dsy", dgrid%asy%d,  dgrid%agy%d    );call from_param("osy", dgrid%asy%o, ggrid%ay_modl%o+(ggrid%ay_modl%n-1)/2*ggrid%ay_modl%d)
        elseif(encode)then
                call from_param("ngx", dgrid%agx%n,  vgrid%ax%n);call from_param("dgx", dgrid%agx%d,  vgrid%ax%d);call from_param("ogx", dgrid%agx%o, vgrid%ax%o)
                call from_param("ngy", dgrid%agy%n,  vgrid%ay%n);call from_param("dgy", dgrid%agy%d,  vgrid%ay%d);call from_param("ogy", dgrid%agy%o, vgrid%ay%o)

                call from_param("nsx", dgrid%asx%n, wgrid%asx%n);call from_param("dsx", dgrid%asx%d,  wgrid%asx%d);call from_param("osx", dgrid%asx%o, wgrid%asx%o)  
                call from_param("nsy", dgrid%asy%n, wgrid%asy%n);call from_param("dsy", dgrid%asy%d,  wgrid%asy%d);call from_param("osy", dgrid%asy%o, wgrid%asy%o)
        elseif(lfixed)then !read from history file
                call from_param("ngx", dgrid%agx%n,  vgrid%ax%n);call from_param("dgx", dgrid%agx%d,  vgrid%ax%d);call from_param("ogx", dgrid%agx%o, vgrid%ax%o)
                call from_param("ngy", dgrid%agy%n,  vgrid%ay%n);call from_param("dgy", dgrid%agy%d,  vgrid%ay%d);call from_param("ogy", dgrid%agy%o, vgrid%ay%o)
        else !read from history file
             
        endif
        !       number of sources after encoding
        encode_nsy=1
        encode_nsx=1
        if(encode)then
                call from_param('encode_nsx',encode_nsx,wgrid%asx%n)
                call from_param('encode_nsy',encode_nsy,wgrid%asy%n)
                dgrid%asx%n=max(1,nint(1.*wgrid%asx%n/encode_nsx))
                dgrid%asy%n=max(1,nint(1.*wgrid%asy%n/encode_nsy))
                dgrid%asx%d=((wgrid%asx%n-1)*wgrid%asx%d)/dgrid%asx%n
                dgrid%asy%d=((wgrid%asy%n-1)*wgrid%asy%d)/dgrid%asy%n
        elseif(exist_file(wavelet_))then
                dgrid%asx=wgrid%asx; encode_nsx=1;
                dgrid%asy=wgrid%asy; encode_nsy=1;
        else
                wgrid%asx=dgrid%asx;encode_nsx=1;
                wgrid%asy=dgrid%asy;encode_nsy=1;
        endif
        if(dgrid%asy%d==0.)dgrid%asy%d=1.
  end subroutine

end module
